(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('rxjs'), require('ng-element-ui/core/utils')) :
    typeof define === 'function' && define.amd ? define('ng-element-ui/affix', ['exports', '@angular/core', 'rxjs', 'ng-element-ui/core/utils'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory((global['ng-element-ui'] = global['ng-element-ui'] || {}, global['ng-element-ui'].affix = {}), global.ng.core, global.rxjs, global['ng-element-ui'].core.utils));
}(this, (function (exports, core, rxjs, utils) { 'use strict';

    var NelAffixComponent = /** @class */ (function () {
        function NelAffixComponent(elementRef) {
            this.elementRef = elementRef;
            this.nelOffset = 0;
            this.nelPosition = 'top';
            this.nelZIndex = 100;
            this.nelOnChange = new core.EventEmitter();
            this.nelOnScroll = new core.EventEmitter();
            this.fixed = false;
            this.width = 0;
            this.height = 0;
            this.reachBottom$ = new rxjs.Subject();
        }
        NelAffixComponent.prototype.ngOnDestroy = function () {
            if (this.subscribeScoll) {
                this.subscribeScoll.unsubscribe();
            }
        };
        NelAffixComponent.prototype.ngAfterViewInit = function () {
            this.width = this.elementRef.nativeElement.offsetWidth;
            this.height = this.elementRef.nativeElement.offsetHeight;
            this.container = utils.getScrollContainer(this.elementRef.nativeElement, true);
            this.initScroll();
            this.handleScroll(true);
        };
        NelAffixComponent.prototype.initScroll = function () {
            var _this = this;
            this.subscribeScoll = rxjs.fromEvent(this.container, 'scroll')
                .subscribe(function () {
                _this.handleScroll();
            });
        };
        NelAffixComponent.prototype.handleScroll = function (init) {
            if (init === void 0) { init = false; }
            var fixed = false;
            if (this.nelPosition === 'top') {
                if (this.elementRef.nativeElement.getBoundingClientRect().top <= this.nelOffset) {
                    fixed = true;
                }
                if (fixed && this.nelTarget) {
                    var difference = this.nelTarget.getBoundingClientRect().bottom - this.nelOffset - this.height;
                    if (difference < 0) {
                        this.fixedEle.nativeElement.style.transform = "translateY(" + difference + "px)";
                        this.fixedEle.nativeElement.style.zIndex = '';
                    }
                    else {
                        this.fixedEle.nativeElement.style.transform = '';
                        this.fixedEle.nativeElement.style.zIndex = this.nelZIndex;
                    }
                    if (this.nelTarget.getBoundingClientRect().bottom < 0) {
                        fixed = false;
                    }
                    else {
                        fixed = true;
                    }
                }
            }
            else {
                if (document.documentElement.clientHeight - this.elementRef.nativeElement.getBoundingClientRect().bottom <= this.nelOffset) {
                    fixed = true;
                }
            }
            if (this.fixed !== fixed) {
                this.changeFixed(fixed);
            }
            if (!init) {
                this.nelOnScroll.emit({ scrollTop: this.container.scrollTop, affix: fixed });
            }
        };
        NelAffixComponent.prototype.changeFixed = function (fixed) {
            var _this = this;
            setTimeout(function () {
                _this.fixed = fixed;
                if (fixed) {
                    _this.elementRef.nativeElement.style.width = _this.width + 'px';
                    _this.elementRef.nativeElement.style.height = _this.height + 'px';
                    _this.fixedEle.nativeElement.style.width = _this.width + 'px';
                    _this.fixedEle.nativeElement.style.height = _this.height + 'px';
                    if (_this.nelPosition === 'top') {
                        _this.fixedEle.nativeElement.style.top = _this.nelOffset + 'px';
                    }
                    else {
                        _this.fixedEle.nativeElement.style.bottom = _this.nelOffset + 'px';
                    }
                }
                else {
                    _this.fixedEle.nativeElement.style.width = '';
                    _this.fixedEle.nativeElement.style.height = '';
                    _this.fixedEle.nativeElement.style.top = '';
                    _this.elementRef.nativeElement.style.width = '';
                    _this.elementRef.nativeElement.style.height = '';
                }
                _this.nelOnChange.emit(fixed);
            }, 0);
        };
        return NelAffixComponent;
    }());
    NelAffixComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'nel-affix',
                    template: "<div #fixedEle [class.el-affix--fixed]=\"fixed\" style=\"z-index: 1000;\">\r\n  <ng-content></ng-content>\r\n</div>\r\n",
                    host: {
                        '[class]': "'el-affix'"
                    }
                },] }
    ];
    NelAffixComponent.ctorParameters = function () { return [
        { type: core.ElementRef }
    ]; };
    NelAffixComponent.propDecorators = {
        nelOffset: [{ type: core.Input }],
        nelTarget: [{ type: core.Input }],
        nelPosition: [{ type: core.Input }],
        nelZIndex: [{ type: core.Input }],
        nelOnChange: [{ type: core.Output }],
        nelOnScroll: [{ type: core.Output }],
        fixedEle: [{ type: core.ViewChild, args: ['fixedEle', { static: false },] }]
    };

    var NelAffixModule = /** @class */ (function () {
        function NelAffixModule() {
        }
        return NelAffixModule;
    }());
    NelAffixModule.decorators = [
        { type: core.NgModule, args: [{
                    declarations: [
                        NelAffixComponent
                    ],
                    exports: [
                        NelAffixComponent
                    ]
                },] }
    ];

    /**
     * Generated bundle index. Do not edit.
     */

    exports.NelAffixComponent = NelAffixComponent;
    exports.NelAffixModule = NelAffixModule;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ng-element-ui-affix.umd.js.map
