(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/common'), require('ng-element-ui/icon')) :
    typeof define === 'function' && define.amd ? define('ng-element-ui/avatar', ['exports', '@angular/core', '@angular/common', 'ng-element-ui/icon'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory((global['ng-element-ui'] = global['ng-element-ui'] || {}, global['ng-element-ui'].avatar = {}), global.ng.core, global.ng.common, global['ng-element-ui'].icon));
}(this, (function (exports, core, common, icon) { 'use strict';

    var NelAvatarComponent = /** @class */ (function () {
        function NelAvatarComponent() {
            this.size = 'large';
            this.loading = false;
            this.nelShape = 'circle';
            this.nelFit = 'cover';
            this.nelOnError = new core.EventEmitter();
        }
        Object.defineProperty(NelAvatarComponent.prototype, "nelSize", {
            set: function (val) {
                if (typeof val === 'number') {
                    this.sizeNum = val;
                    this.size = undefined;
                }
                else {
                    this.sizeNum = undefined;
                    this.size = val;
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(NelAvatarComponent.prototype, "nelSrc", {
            set: function (val) {
                var _this = this;
                this.loading = true;
                var img = new Image();
                img.src = val;
                img.onload = function (e) {
                    _this.src = val;
                    _this.loading = false;
                };
                img.onerror = function (e) {
                    if (e instanceof Event) {
                        e.preventDefault();
                        e.stopPropagation();
                    }
                    _this.nelOnError.emit(e);
                    _this.loading = false;
                };
            },
            enumerable: false,
            configurable: true
        });
        return NelAvatarComponent;
    }());
    NelAvatarComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'nel-avatar',
                    template: "<span class=\"el-avatar el-avatar--{{nelShape}}\" [class.el-avatar--large]=\"size == 'large'\"\r\n  [class.el-avatar--medium]=\"size == 'medium'\" [class.el-avatar--small]=\"size == 'small'\"\r\n  [class.el-avatar--icon]=\"nelIcon\" [style.height]=\"sizeNum! + 'px'\" [style.width]=\"sizeNum! + 'px'\"\r\n  [style.line-height]=\"sizeNum! + 'px'\">\r\n  <i *ngIf=\"nelIcon\" nel-icon [nelType]=\"nelIcon\"></i>\r\n  <img *ngIf=\"src\" [src]=\"src\" [style.object-fit]=\"nelFit\" [alt]=\"nelAlt\">\r\n  <ng-container *ngIf=\"nelText\">{{nelText}}</ng-container>\r\n  <ng-content *ngIf=\"!loading\"></ng-content>\r\n</span>\r\n"
                },] }
    ];
    NelAvatarComponent.propDecorators = {
        nelIcon: [{ type: core.Input }],
        nelSize: [{ type: core.Input }],
        nelText: [{ type: core.Input }],
        nelShape: [{ type: core.Input }],
        nelSrc: [{ type: core.Input }],
        nelAlt: [{ type: core.Input }],
        nelFit: [{ type: core.Input }],
        nelOnError: [{ type: core.Output }]
    };

    var NelAvatarModule = /** @class */ (function () {
        function NelAvatarModule() {
        }
        return NelAvatarModule;
    }());
    NelAvatarModule.decorators = [
        { type: core.NgModule, args: [{
                    declarations: [
                        NelAvatarComponent
                    ],
                    exports: [
                        NelAvatarComponent
                    ],
                    imports: [
                        common.CommonModule,
                        icon.NelIconModule
                    ]
                },] }
    ];

    /**
     * Generated bundle index. Do not edit.
     */

    exports.NelAvatarComponent = NelAvatarComponent;
    exports.NelAvatarModule = NelAvatarModule;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ng-element-ui-avatar.umd.js.map
