(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/common'), require('rxjs'), require('ng-element-ui/core/animation'), require('ng-element-ui/icon')) :
    typeof define === 'function' && define.amd ? define('ng-element-ui/backtop', ['exports', '@angular/core', '@angular/common', 'rxjs', 'ng-element-ui/core/animation', 'ng-element-ui/icon'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory((global['ng-element-ui'] = global['ng-element-ui'] || {}, global['ng-element-ui'].backtop = {}), global.ng.core, global.ng.common, global.rxjs, global['ng-element-ui'].core.animation, global['ng-element-ui'].icon));
}(this, (function (exports, core, common, rxjs, animation, icon) { 'use strict';

    var NelBacktopComponent = /** @class */ (function () {
        function NelBacktopComponent(doc, cdr) {
            this.cdr = cdr;
            this.visible = false;
            this.nelVisibilityHeight = 200;
            this.nelRight = 40;
            this.nelBottom = 40;
            this.nelClick = new core.EventEmitter();
            this.target = null;
            this.doc = doc;
        }
        NelBacktopComponent.prototype.ngOnDestroy = function () {
            this.subscribeScoll.unsubscribe();
        };
        NelBacktopComponent.prototype.ngAfterViewInit = function () {
            this.initTarget();
        };
        NelBacktopComponent.prototype.initTarget = function () {
            if (typeof this.nelTarget === 'string') {
                this.target = this.doc.querySelector(this.nelTarget);
            }
            else {
                this.target = this.nelTarget;
            }
            this.registerScrollEvent();
        };
        NelBacktopComponent.prototype.getTarget = function () {
            return this.target || window;
        };
        NelBacktopComponent.prototype.getScroll = function () {
            var target = this.getTarget();
            if (target instanceof HTMLElement) {
                return target.scrollTop;
            }
            else {
                return target.pageYOffset;
            }
        };
        NelBacktopComponent.prototype.registerScrollEvent = function () {
            var _this = this;
            if (this.subscribeScoll) {
                this.subscribeScoll.unsubscribe();
            }
            this.subscribeScoll = rxjs.fromEvent(this.getTarget(), 'scroll')
                .subscribe(function () {
                _this.handleScroll();
            });
        };
        NelBacktopComponent.prototype.handleScroll = function () {
            if (this.getScroll() > this.nelVisibilityHeight) {
                this.visible = true;
            }
            else {
                this.visible = false;
            }
            this.cdr.detectChanges();
        };
        NelBacktopComponent.prototype.backTop = function () {
            this.scrollTop();
            this.nelClick.emit();
        };
        NelBacktopComponent.prototype.scrollTop = function () {
            var target = this.getTarget();
            target.scrollTo({ top: 0, behavior: 'smooth' });
        };
        NelBacktopComponent.prototype.ngOnChanges = function (changes) {
            var nelTarget = changes.nelTarget;
            if (nelTarget && !nelTarget.firstChange) {
                this.initTarget();
            }
        };
        return NelBacktopComponent;
    }());
    NelBacktopComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'nel-backtop',
                    template: "<div class=\"el-backtop\" (click)=\"backTop()\" *ngIf=\"visible\" @fadeMotion [style.right]=\"nelRight + 'px'\"\r\n  [style.bottom]=\"nelBottom + 'px'\">\r\n  <i *ngIf=\"!nelTemplate\" nel-icon [nelType]=\"'caret-top'\"></i>\r\n  <ng-container *ngTemplateOutlet=\"nelTemplate\"></ng-container>\r\n</div>\r\n",
                    changeDetection: core.ChangeDetectionStrategy.OnPush,
                    animations: [animation.fadeMotion]
                },] }
    ];
    NelBacktopComponent.ctorParameters = function () { return [
        { type: undefined, decorators: [{ type: core.Inject, args: [common.DOCUMENT,] }] },
        { type: core.ChangeDetectorRef }
    ]; };
    NelBacktopComponent.propDecorators = {
        nelTarget: [{ type: core.Input }],
        nelVisibilityHeight: [{ type: core.Input }],
        nelRight: [{ type: core.Input }],
        nelBottom: [{ type: core.Input }],
        nelTemplate: [{ type: core.Input }],
        nelClick: [{ type: core.Output }]
    };

    var NelBacktopModule = /** @class */ (function () {
        function NelBacktopModule() {
        }
        return NelBacktopModule;
    }());
    NelBacktopModule.decorators = [
        { type: core.NgModule, args: [{
                    declarations: [
                        NelBacktopComponent
                    ],
                    exports: [
                        NelBacktopComponent
                    ],
                    imports: [
                        common.CommonModule,
                        icon.NelIconModule
                    ]
                },] }
    ];

    /**
     * Generated bundle index. Do not edit.
     */

    exports.NelBacktopComponent = NelBacktopComponent;
    exports.NelBacktopModule = NelBacktopModule;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ng-element-ui-backtop.umd.js.map
