(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/common'), require('@angular/cdk/overlay'), require('ng-element-ui/button')) :
    typeof define === 'function' && define.amd ? define('ng-element-ui/carousel', ['exports', '@angular/core', '@angular/common', '@angular/cdk/overlay', 'ng-element-ui/button'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory((global['ng-element-ui'] = global['ng-element-ui'] || {}, global['ng-element-ui'].carousel = {}), global.ng.core, global.ng.common, global.ng.cdk.overlay, global['ng-element-ui'].button));
}(this, (function (exports, core, common, overlay, button) { 'use strict';

    var NelCarouselItemComponent = /** @class */ (function () {
        function NelCarouselItemComponent() {
            this.left = '';
            this.top = '';
        }
        return NelCarouselItemComponent;
    }());
    NelCarouselItemComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'nel-carousel-item',
                    template: "<ng-content></ng-content>\r\n",
                    changeDetection: core.ChangeDetectionStrategy.OnPush,
                    host: {
                        class: 'el-carousel__item',
                        '[style.left]': 'left',
                        '[style.top]': 'top',
                    }
                },] }
    ];

    var NelCarouselComponent = /** @class */ (function () {
        function NelCarouselComponent() {
            this.hover = false;
            this.width = 0;
            this.height = 0;
            this.active = -1;
            this.CARD_SCALE = 0.83;
            this.nelArrow = 'hover';
            this.nelDirection = 'horizontal';
        }
        NelCarouselComponent.prototype.ngOnDestroy = function () {
        };
        NelCarouselComponent.prototype.ngAfterViewInit = function () {
            var _this = this;
            var client = this.containerEle.nativeElement.getBoundingClientRect();
            this.width = client.width;
            this.height = client.height;
            if (this.nelDirection === 'horizontal') {
                this.itemContainerEle.nativeElement.style.width = (this.items.length * 100) + '%';
            }
            else {
                this.itemContainerEle.nativeElement.style.height = (this.items.length * 100) + '%';
            }
            setTimeout(function () {
                _this.changeActive(0, true);
            }, 0);
        };
        NelCarouselComponent.prototype.mouseEnter = function () {
            this.hover = true;
        };
        NelCarouselComponent.prototype.mouseLeave = function () {
            this.hover = false;
        };
        NelCarouselComponent.prototype.prev = function () {
            var active = this.active - 1;
            if (active < 0) {
                active = this.items.length - 1;
                this.items.last.left = -this.items.length * this.width + "px";
                // return;
            }
            this.changeActive(active, false);
        };
        NelCarouselComponent.prototype.next = function () {
            var active = this.active + 1;
            if (active >= this.items.length) {
                active = 0;
                this.items.first.left = this.items.length * this.width + "px";
            }
            this.changeActive(active, false);
        };
        NelCarouselComponent.prototype.indicatorSelect = function (index) {
            if (this.nelTrigger !== 'click') {
                this.changeActive(index, true);
            }
        };
        NelCarouselComponent.prototype.selectItem = function (index) {
            this.changeActive(index, true);
        };
        NelCarouselComponent.prototype.changeActive = function (active, indicator) {
            var _this = this;
            if (this.active === active) {
                return;
            }
            if (this.active !== -1) {
                if (this.nelDirection === 'horizontal') {
                    if (!indicator) {
                        var difference = active;
                        if (active === 0) {
                            // 从last切换到first
                            if (this.active === this.items.length - 1) {
                                difference = this.items.length;
                            }
                        }
                        else if (active === this.items.length - 1) {
                            // 从first切换到last
                            if (this.active === 0) {
                                difference = -1;
                            }
                        }
                        this.itemContainerEle.nativeElement.style.transition = 'transform .3s';
                        this.itemContainerEle.nativeElement.style.transform = "translate3d(" + -difference * this.width + "px, 0px, 0px)";
                        // 将first或者last的left重置为空
                        setTimeout(function () {
                            if (active === 0) {
                                _this.itemContainerEle.nativeElement.style.transition = '';
                                _this.items.first.left = '';
                                _this.itemContainerEle.nativeElement.style.transform = 'translate3d(0px, 0px, 0px)';
                            }
                            else if (active === _this.items.length - 1) {
                                _this.itemContainerEle.nativeElement.style.transition = '';
                                _this.items.last.left = '';
                                _this.itemContainerEle.nativeElement.style.transform = "translate3d(" + -(_this.items.length - 1) * _this.width + "px, 0px, 0px)";
                            }
                        }, 300);
                    }
                    else {
                        this.itemContainerEle.nativeElement.style.transition = 'transform .3s';
                        this.itemContainerEle.nativeElement.style.transform = "translate3d(" + -active * this.width + "px, 0px, 0px)";
                    }
                }
                else {
                    if (!indicator) {
                        var difference = active;
                        if (active === 0) {
                            // 从last切换到first
                            if (this.active === this.items.length - 1) {
                                difference = this.items.length;
                            }
                        }
                        else if (active === this.items.length - 1) {
                            // 从first切换到last
                            if (this.active === 0) {
                                difference = -1;
                            }
                        }
                        this.itemContainerEle.nativeElement.style.transition = 'transform .3s';
                        this.itemContainerEle.nativeElement.style.transform = "translate3d(0px, " + -difference * this.height + "px, 0px)";
                        // 将first或者last的left重置为空
                        setTimeout(function () {
                            if (active === 0) {
                                _this.itemContainerEle.nativeElement.style.transition = '';
                                _this.items.first.top = '';
                                _this.itemContainerEle.nativeElement.style.transform = 'translate3d(0px, 0px, 0px)';
                            }
                            else if (active === _this.items.length - 1) {
                                _this.itemContainerEle.nativeElement.style.transition = '';
                                _this.items.last.left = '';
                                _this.itemContainerEle.nativeElement.style.transform = "translate3d(0px, " + -(_this.items.length - 1) * _this.height + "px, 0px)";
                            }
                        }, 300);
                    }
                    else {
                        this.itemContainerEle.nativeElement.style.transition = 'transform .3s';
                        this.itemContainerEle.nativeElement.style.transform = "translate3d(0px, " + -active * this.height + "px, 0px)";
                    }
                }
            }
            this.active = active;
        };
        return NelCarouselComponent;
    }());
    NelCarouselComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'nel-carousel',
                    template: "<div class=\"el-carousel el-carousel--{{nelDirection}}\" (mouseenter)=\"mouseEnter()\" (mouseleave)=\"mouseLeave()\">\r\n  <div #containerEle class=\"el-carousel__container\" [style.height]=\"nelHeight\">\r\n    <button *ngIf=\"nelDirection === 'horizontal' && nelArrow !== 'never'\" (click)=\"prev()\" type=\"button\"\r\n      class=\"el-carousel__arrow el-carousel__arrow--left\"\r\n      [style.display]=\"nelArrow === 'always' || hover ? '' : 'none'\">\r\n      <i class=\"el-icon-arrow-left\"></i>\r\n    </button>\r\n    <button *ngIf=\"nelDirection === 'horizontal' && nelArrow !== 'never'\" (click)=\"next()\" type=\"button\"\r\n      class=\"el-carousel__arrow el-carousel__arrow--right\"\r\n      [style.display]=\"nelArrow === 'always' || hover ? '' : 'none'\">\r\n      <i class=\"el-icon-arrow-right\"></i>\r\n    </button>\r\n    <div class=\"el-carousel__item__wrapper\">\r\n      <div #itemContainerEle class=\"el-carousel__item__container\"\r\n        [style.flex-direction]=\"nelDirection == 'vertical' ? 'column' : ''\">\r\n        <ng-content></ng-content>\r\n      </div>\r\n    </div>\r\n  </div>\r\n  <ul class=\"el-carousel__indicators el-carousel__indicators--{{nelDirection}}\"\r\n    [class.el-carousel__indicators--outside]=\"nelIndicatorPosition == 'outside'\">\r\n    <li #indicatorEle (mouseenter)=\"indicatorSelect(index)\" (click)=\"selectItem(index)\"\r\n      *ngFor=\"let item of items; let index=index;\"\r\n      class=\"el-carousel__indicator el-carousel__indicator--{{nelDirection}}\" [class.is-active]=\"index == active\">\r\n      <button class=\"el-carousel__button\"></button>\r\n    </li>\r\n  </ul>\r\n</div>\r\n",
                    changeDetection: core.ChangeDetectionStrategy.OnPush
                },] }
    ];
    NelCarouselComponent.ctorParameters = function () { return []; };
    NelCarouselComponent.propDecorators = {
        nelHeight: [{ type: core.Input }],
        nelTrigger: [{ type: core.Input }],
        nelIndicatorPosition: [{ type: core.Input }],
        nelArrow: [{ type: core.Input }],
        nelType: [{ type: core.Input }],
        nelDirection: [{ type: core.Input }],
        items: [{ type: core.ContentChildren, args: [NelCarouselItemComponent, { descendants: false },] }],
        containerEle: [{ type: core.ViewChild, args: ['containerEle', { static: false },] }],
        itemContainerEle: [{ type: core.ViewChild, args: ['itemContainerEle', { static: false },] }],
        indicatorList: [{ type: core.ViewChildren, args: ['indicatorEle',] }]
    };

    var NelCarouselModule = /** @class */ (function () {
        function NelCarouselModule() {
        }
        return NelCarouselModule;
    }());
    NelCarouselModule.decorators = [
        { type: core.NgModule, args: [{
                    declarations: [
                        NelCarouselComponent,
                        NelCarouselItemComponent
                    ],
                    exports: [
                        NelCarouselComponent,
                        NelCarouselItemComponent
                    ],
                    imports: [
                        common.CommonModule,
                        overlay.OverlayModule,
                        button.NelButtonModule
                    ]
                },] }
    ];

    /**
     * Generated bundle index. Do not edit.
     */

    exports.NelCarouselComponent = NelCarouselComponent;
    exports.NelCarouselItemComponent = NelCarouselItemComponent;
    exports.NelCarouselModule = NelCarouselModule;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ng-element-ui-carousel.umd.js.map
