(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/animations')) :
    typeof define === 'function' && define.amd ? define('ng-element-ui/core/animation', ['exports', '@angular/animations'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory((global['ng-element-ui'] = global['ng-element-ui'] || {}, global['ng-element-ui'].core = global['ng-element-ui'].core || {}, global['ng-element-ui'].core.animation = {}), global.ng.animations));
}(this, (function (exports, animations) { 'use strict';

    var fadeMotion = animations.trigger('fadeMotion', [
        animations.transition(':enter', [
            animations.style({ opacity: 0 }),
            animations.animate(300, animations.style({ opacity: 1 }))
        ]),
        animations.transition(':leave', [
            animations.animate(300, animations.style({ opacity: 0 }))
        ])
    ]);

    var collapseMotion = animations.trigger('collapseMotion', [
        animations.state('expanded', animations.style({
            display: 'block',
            opacity: '1'
        })),
        animations.state('collapsed', animations.style({
            display: 'none',
            height: '0',
            opacity: '0'
        })),
        animations.transition('expanded <=> collapsed', [
            animations.style({ display: 'block' }),
            animations.animate('300ms')
        ])
    ]);

    var zoomMotion = animations.trigger('zoomMotion', [
        animations.transition(':enter', [
            animations.style({ opacity: 0, transform: 'scaleX(0)' }),
            animations.animate(300, animations.style({ opacity: 1, transform: 'scaleX(1)' }))
        ]),
        animations.transition(':leave', [
            animations.animate(300, animations.style({ opacity: 0, transform: 'scaleX(0)' }))
        ])
    ]);
    var zoomTopMotion = animations.trigger('zoomTopMotion', [
        animations.transition(':enter', [
            animations.style({ transform: 'scaleY(0)', 'transform-origin': 'center top' }),
            animations.animate(300, animations.style({ transform: 'scaleY(1)', 'transform-origin': 'center bottom' }))
        ]),
        animations.transition(':leave', [
            animations.animate(300, animations.style({ transform: 'scaleY(0)', 'transform-origin': 'center top' }))
        ])
    ]);
    var zoomBottomMotion = animations.trigger('zoomBottomMotion', [
        animations.transition(':enter', [
            animations.style({ opacity: 0, transform: 'scaleY(0)', 'transform-origin': 'center bottom' }),
            animations.animate(300, animations.style({ opacity: 1, transform: 'scaleY(1)', 'transform-origin': 'center top' }))
        ]),
        animations.transition(':leave', [
            animations.animate(300, animations.style({ opacity: 0, transform: 'scaleY(0)', 'transform-origin': 'center bottom' }))
        ])
    ]);

    var drawerMotion = animations.trigger('drawerMotion', [
        animations.transition(':enter', [
            animations.style({ opacity: 0, overflow: 'hidden' }),
            animations.group([
                animations.query('@drawerDialogMotion', [animations.animateChild()]),
                animations.animate(300, animations.style({ opacity: 1 }))
            ])
        ]),
        animations.transition(':leave', [
            animations.style({ overflow: 'hidden' }),
            animations.group([
                animations.query('@drawerDialogMotion', [animations.animateChild()]),
                animations.animate(300, animations.style({ opacity: 0 }))
            ])
        ])
    ]);
    var drawerDialogMotion = animations.trigger('drawerDialogMotion', [
        animations.transition('void => rtl', [
            animations.style({ transform: 'translate(100%, 0px)' }),
            animations.animate(300, animations.style({ transform: 'translate(0px, 0px)' }))
        ]),
        animations.transition('rtl => void', [
            animations.style({ transform: 'translate(0px, 0px)' }),
            animations.animate(300, animations.style({ transform: 'translate(100%, 0px)' }))
        ]),
        animations.transition('void => ltr', [
            animations.style({ transform: 'translate(-100%, 0px)' }),
            animations.animate(300, animations.style({ transform: 'translate(0px, 0px)' }))
        ]),
        animations.transition('ltr => void', [
            animations.style({ transform: 'translate(0px, 0px)' }),
            animations.animate(300, animations.style({ transform: 'translate(-100%, 0px)' }))
        ]),
        animations.transition('void => ttb', [
            animations.style({ transform: 'translate(0px, -100%)' }),
            animations.animate(300, animations.style({ transform: 'translate(0px, 0px)' }))
        ]),
        animations.transition('ttb => void', [
            animations.style({ transform: 'translate(0px, 0px)' }),
            animations.animate(300, animations.style({ transform: 'translate(0px, -100%)' }))
        ]),
        animations.transition('void => btt', [
            animations.style({ transform: 'translate(0px, 100%)' }),
            animations.animate(300, animations.style({ transform: 'translate(0px, 0px)' }))
        ]),
        animations.transition('btt => void', [
            animations.style({ transform: 'translate(0px, 0px)' }),
            animations.animate(300, animations.style({ transform: 'translate(0px, 100%)' }))
        ])
    ]);

    var modalMotion = animations.trigger('modalMotion', [
        animations.transition(':enter', [
            animations.style({
                opacity: 0,
                transform: 'translate3d(0, -20px, 0)'
            }),
            animations.animate(300, animations.style({
                opacity: 1,
                transform: 'translate3d(0, 0, 0)'
            }))
        ]),
        animations.transition(':leave', [
            animations.style({
                opacity: 1,
                transform: 'translate3d(0, 0, 0)'
            }),
            animations.animate(300, animations.style({
                opacity: 0,
                transform: 'translate3d(0, -20px, 0)'
            }))
        ]),
    ]);

    var messageMotion = animations.trigger('messageMotion', [
        animations.state('done', animations.style({
            opacity: 1,
            transform: 'translate(-50%, 0)'
        })),
        animations.transition(':enter', [
            animations.style({
                opacity: 0,
                transform: 'translate(-50%, -100%)'
            }),
            animations.animate(300, animations.style({
                opacity: 1,
                transform: 'translate(-50%, 0)'
            }))
        ]),
        animations.transition('start => done', [
            animations.animate(300, animations.style({
                opacity: 0,
                transform: 'translate(-50%, -100%)'
            }))
        ])
    ]);

    var notificationMotion = animations.trigger('notificationMotion', [
        animations.transition('void => rightInto', [
            animations.style({
                opacity: 0,
                transform: 'translate(100%, 0)'
            }),
            animations.animate(300, animations.style({
                opacity: 1,
                transform: 'translate(0, 0)'
            }))
        ]),
        animations.transition('rightInto => leave', [
            animations.style({
                opacity: 1,
                transform: 'translate(0, 0)'
            }),
            animations.animate(300, animations.style({
                opacity: 0,
                transform: 'translate(100%, 0)'
            }))
        ]),
        animations.transition('void => leftInto', [
            animations.style({
                opacity: 0,
                transform: 'translate(-100%, 0)'
            }),
            animations.animate(300, animations.style({
                opacity: 1,
                transform: 'translate(0, 0)'
            }))
        ]),
        animations.transition('leftInto => leave', [
            animations.style({
                opacity: 1,
                transform: 'translate(0, 0)'
            }),
            animations.animate(300, animations.style({
                opacity: 0,
                transform: 'translate(-100%, 0)'
            }))
        ]),
    ]);

    var messageBoxMotion = animations.trigger('messageBoxMotion', [
        animations.transition('void => into', [
            animations.style({
                opacity: 0,
                transform: 'translate(0, -20px)'
            }),
            animations.animate(300, animations.style({
                opacity: 1,
                transform: 'translate(0, 0)'
            }))
        ]),
        animations.transition('into => leave', [
            animations.style({
                opacity: 1,
                transform: 'translate(0, 0)'
            }),
            animations.animate(300, animations.style({
                opacity: 0,
                transform: 'translate(0, -20px)'
            }))
        ])
    ]);

    var loadingMotion = animations.trigger('loadingMotion', [
        animations.transition(':enter', [
            animations.style({ opacity: 0 }),
            animations.animate(300, animations.style({ opacity: 1 }))
        ]),
        animations.transition(':leave', [
            animations.animate(300, animations.style({ opacity: 0 }))
        ])
    ]);

    var dropdownMotion = animations.trigger('dropdownMotion', [
        animations.transition('void => into, leave => into', [
            animations.style({
                opacity: 0,
                transform: 'scaleY(0)',
                'transform-origin': 'center top'
            }),
            animations.animate(300, animations.style({
                opacity: 1,
                transform: 'scaleY(1)',
                'transform-origin': 'center top'
            }))
        ]),
        animations.transition(':leave', [
            animations.style({
                opacity: 1,
                transform: 'scaleY(1)',
                'transform-origin': 'center top'
            }),
            animations.animate(300, animations.style({
                opacity: 0,
                transform: 'scaleY(0)',
                'transform-origin': 'center top'
            }))
        ])
    ]);

    /**
     * Generated bundle index. Do not edit.
     */

    exports.collapseMotion = collapseMotion;
    exports.drawerDialogMotion = drawerDialogMotion;
    exports.drawerMotion = drawerMotion;
    exports.dropdownMotion = dropdownMotion;
    exports.fadeMotion = fadeMotion;
    exports.loadingMotion = loadingMotion;
    exports.messageBoxMotion = messageBoxMotion;
    exports.messageMotion = messageMotion;
    exports.modalMotion = modalMotion;
    exports.notificationMotion = notificationMotion;
    exports.zoomBottomMotion = zoomBottomMotion;
    exports.zoomMotion = zoomMotion;
    exports.zoomTopMotion = zoomTopMotion;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ng-element-ui-core-animation.umd.js.map
