(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/cdk/coercion')) :
    typeof define === 'function' && define.amd ? define('ng-element-ui/core/utils', ['exports', '@angular/cdk/coercion'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory((global['ng-element-ui'] = global['ng-element-ui'] || {}, global['ng-element-ui'].core = global['ng-element-ui'].core || {}, global['ng-element-ui'].core.utils = {}), global.ng.cdk.coercion));
}(this, (function (exports, coercion) { 'use strict';

    var getScrollContainer = function (el, isVertical) {
        var parent = el;
        while (parent) {
            if ([window, document, document.documentElement].includes(parent)) {
                return window.document.body;
            }
            if (isScroll(parent, isVertical)) {
                return parent;
            }
            parent = parent.parentNode;
        }
        return parent;
    };
    var isScroll = function (el, isVertical) {
        var determinedDirection = isVertical === null || isVertical === undefined;
        var overflow = determinedDirection
            ? getStyle(el, 'overflow')
            : isVertical
                ? getStyle(el, 'overflow-y')
                : getStyle(el, 'overflow-x');
        if (overflow) {
            return overflow.match(/(scroll|auto)/);
        }
        else {
            return null;
        }
    };
    var getStyle = function (element, styleName) {
        if (!element || !styleName) {
            return null;
        }
        // styleName = camelize(styleName)
        if (styleName === 'float') {
            styleName = 'cssFloat';
        }
        try {
            var style = element.style[styleName];
            if (style)
                return style;
            var computed = getComputedStyle(element, '');
            return computed ? computed[styleName] : '';
        }
        catch (e) {
            return element.style[styleName];
        }
    };

    function toBoolean(value) {
        return coercion.coerceBooleanProperty(value);
    }
    function propDecoratorFactory(name, fallback) {
        function propDecorator(target, propName, originalDescriptor) {
            var privatePropName = "$$__" + propName;
            if (Object.prototype.hasOwnProperty.call(target, privatePropName)) {
                console.warn("The prop \"" + privatePropName + "\" is already exist, it will be overrided by " + name + " decorator.");
            }
            Object.defineProperty(target, privatePropName, {
                configurable: true,
                writable: true
            });
            return {
                get: function () {
                    return originalDescriptor && originalDescriptor.get
                        ? originalDescriptor.get.bind(this)()
                        : this[privatePropName];
                },
                set: function (value) {
                    if (originalDescriptor && originalDescriptor.set) {
                        originalDescriptor.set.bind(this)(fallback(value));
                    }
                    this[privatePropName] = fallback(value);
                }
            };
        }
        return propDecorator;
    }
    function InputBoolean() {
        return propDecoratorFactory('InputBoolean', toBoolean);
    }

    /**
     * Generated bundle index. Do not edit.
     */

    exports.InputBoolean = InputBoolean;
    exports.getScrollContainer = getScrollContainer;
    exports.getStyle = getStyle;
    exports.isScroll = isScroll;
    exports.toBoolean = toBoolean;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ng-element-ui-core-utils.umd.js.map
