(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('ng-element-ui/core/animation'), require('rxjs'), require('@angular/common'), require('@angular/cdk/overlay'), require('ng-element-ui/core/outlet')) :
    typeof define === 'function' && define.amd ? define('ng-element-ui/drawer', ['exports', '@angular/core', 'ng-element-ui/core/animation', 'rxjs', '@angular/common', '@angular/cdk/overlay', 'ng-element-ui/core/outlet'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory((global['ng-element-ui'] = global['ng-element-ui'] || {}, global['ng-element-ui'].drawer = {}), global.ng.core, global['ng-element-ui'].core.animation, global.rxjs, global.ng.common, global.ng.cdk.overlay, global['ng-element-ui'].core.outlet));
}(this, (function (exports, core, animation, rxjs, common, overlay, outlet) { 'use strict';

    var NelDrawerComponent = /** @class */ (function () {
        function NelDrawerComponent(hostView, elementRef) {
            this.hostView = hostView;
            this.elementRef = elementRef;
            this.width = '30%';
            this.height = '30%';
            this.nelDirection = 'rtl';
            this.nelWithHeader = true;
            this.nelShowClose = true;
            this.nelVisibleChange = new core.EventEmitter();
            this.isOpen = false;
        }
        Object.defineProperty(NelDrawerComponent.prototype, "nelSize", {
            set: function (val) {
                if (typeof val === 'number') {
                    this.width = val + 'px';
                    this.height = val + 'px';
                }
                else {
                    this.width = val;
                    this.height = val;
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(NelDrawerComponent.prototype, "nelVisible", {
            set: function (val) {
                if (val) {
                    this.show();
                }
                else {
                    if (this.isOpen) {
                        this.close();
                    }
                }
            },
            enumerable: false,
            configurable: true
        });
        NelDrawerComponent.prototype.show = function () {
            this.trigger = { elementRef: this.elementRef };
            this.isOpen = true;
        };
        NelDrawerComponent.prototype.handleClose = function () {
            var _this = this;
            if (this.isOpen && this.nelBeforeClose) {
                var before = this.nelBeforeClose();
                if (before instanceof rxjs.Observable) {
                    before.subscribe(function (data) {
                        if (data) {
                            _this.close();
                        }
                    }, function (err) {
                        console.error(err);
                    });
                }
                else if (before !== false) {
                    this.close();
                }
            }
            else {
                this.close();
            }
        };
        NelDrawerComponent.prototype.close = function () {
            this.isOpen = false;
            this.nelVisibleChange.emit(false);
        };
        NelDrawerComponent.prototype.clickDrawer = function ($event) {
            $event.stopPropagation();
        };
        return NelDrawerComponent;
    }());
    NelDrawerComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'nel-drawer',
                    template: "<ng-template cdkConnectedOverlay [cdkConnectedOverlayOrigin]=\"trigger\" [cdkConnectedOverlayOpen]=\"isOpen\">\r\n  <div class=\"el-overlay\" (click)=\"handleClose()\" @drawerMotion>\r\n    <div class=\"el-drawer {{nelDirection}}\" role=\"dialog\" (click)=\"clickDrawer($event)\"\r\n      [style.width]=\"nelDirection=='ltr' || nelDirection=='rtl' ? width : ''\"\r\n      [style.height]=\"nelDirection=='ttb' || nelDirection=='btt' ? height : ''\" [@drawerDialogMotion]=\"nelDirection\">\r\n      <header *ngIf=\"nelWithHeader\" class=\"el-drawer__header\">\r\n        <span *ngIf=\"nelTitle\" role=\"heading\">\r\n          <ng-container *stringTemplate=\"nelTitle\">{{nelTitle}}</ng-container>\r\n        </span>\r\n        <button *ngIf=\"nelShowClose\" (click)=\"handleClose()\" class=\"el-drawer__close-btn\" type=\"button\">\r\n          <i class=\"el-drawer__close el-icon el-icon-close\"></i>\r\n        </button>\r\n      </header>\r\n      <section class=\"el-drawer__body\">\r\n        <ng-content></ng-content>\r\n      </section>\r\n    </div>\r\n  </div>\r\n</ng-template>\r\n",
                    animations: [animation.drawerMotion, animation.drawerDialogMotion]
                },] }
    ];
    NelDrawerComponent.ctorParameters = function () { return [
        { type: core.ViewContainerRef },
        { type: core.ElementRef }
    ]; };
    NelDrawerComponent.propDecorators = {
        nelTitle: [{ type: core.Input }],
        nelDirection: [{ type: core.Input }],
        nelWithHeader: [{ type: core.Input }],
        nelShowClose: [{ type: core.Input }],
        nelBeforeClose: [{ type: core.Input }],
        nelSize: [{ type: core.Input }],
        nelVisible: [{ type: core.Input }],
        nelVisibleChange: [{ type: core.Output }]
    };

    var NelDrawerModule = /** @class */ (function () {
        function NelDrawerModule() {
        }
        return NelDrawerModule;
    }());
    NelDrawerModule.decorators = [
        { type: core.NgModule, args: [{
                    declarations: [
                        NelDrawerComponent
                    ],
                    exports: [
                        NelDrawerComponent
                    ],
                    imports: [
                        common.CommonModule,
                        overlay.OverlayModule,
                        outlet.NelOutletModule
                    ]
                },] }
    ];

    /**
     * Generated bundle index. Do not edit.
     */

    exports.NelDrawerComponent = NelDrawerComponent;
    exports.NelDrawerModule = NelDrawerModule;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ng-element-ui-drawer.umd.js.map
