(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('ng-element-ui/core/utils'), require('rxjs'), require('rxjs/operators')) :
    typeof define === 'function' && define.amd ? define('ng-element-ui/infinite-scroll', ['exports', '@angular/core', 'ng-element-ui/core/utils', 'rxjs', 'rxjs/operators'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory((global['ng-element-ui'] = global['ng-element-ui'] || {}, global['ng-element-ui']['infinite-scroll'] = {}), global.ng.core, global['ng-element-ui'].core.utils, global.rxjs, global.rxjs.operators));
}(this, (function (exports, core, utils, rxjs, operators) { 'use strict';

    var NelInfiniteScrollDirective = /** @class */ (function () {
        function NelInfiniteScrollDirective(elementRef) {
            this.elementRef = elementRef;
            this.reachBottom$ = new rxjs.Subject();
            this.disabled = false;
            // 是否初始化
            this.initData = false;
            this.nelDistance = 0;
            this.nelDelay = 200;
            this.nelImmediate = true;
            this.nelOnReachBottom = new core.EventEmitter();
        }
        Object.defineProperty(NelInfiniteScrollDirective.prototype, "nelDisabled", {
            set: function (value) {
                this.disabled = value;
                if (this.initData) {
                    if (value) {
                        if (this.subscribeScoll) {
                            this.subscribeScoll.unsubscribe();
                        }
                        if (this.subscribeReachBottom) {
                            this.subscribeReachBottom.unsubscribe();
                        }
                    }
                    else {
                        this.initScroll();
                    }
                }
            },
            enumerable: false,
            configurable: true
        });
        NelInfiniteScrollDirective.prototype.ngOnDestroy = function () {
            if (this.subscribeScoll) {
                this.subscribeScoll.unsubscribe();
            }
            if (this.subscribeReachBottom) {
                this.subscribeReachBottom.unsubscribe();
            }
        };
        NelInfiniteScrollDirective.prototype.ngAfterViewInit = function () {
            this.container = utils.getScrollContainer(this.elementRef.nativeElement, true);
            if (!this.disabled) {
                this.initScroll();
                this.initImmediate();
            }
            this.initData = true;
        };
        NelInfiniteScrollDirective.prototype.initScroll = function () {
            var _this = this;
            this.subscribeReachBottom = this.reachBottom$.asObservable().pipe(operators.debounceTime(this.nelDelay)).subscribe(function () {
                _this.nelOnReachBottom.emit();
            });
            this.subscribeScoll = rxjs.fromEvent(this.container, 'scroll')
                .subscribe(function () {
                _this.handleScroll();
            });
        };
        NelInfiniteScrollDirective.prototype.initImmediate = function () {
            var _this = this;
            if (this.nelImmediate) {
                this.observer = new MutationObserver(function (mutations) {
                    _this.immediate();
                });
                var config = { childList: true, subtree: true };
                this.observer.observe(this.container, config);
                // 查询滚动的父元素
                this.immediate();
            }
        };
        NelInfiniteScrollDirective.prototype.immediate = function () {
            if (this.container.scrollHeight <= this.container.clientHeight) {
                this.nelOnReachBottom.emit();
            }
            else {
                if (this.observer) {
                    this.observer.disconnect();
                }
            }
        };
        NelInfiniteScrollDirective.prototype.handleScroll = function () {
            if (this.container.scrollHeight - this.container.clientHeight
                - this.container.scrollTop <= this.nelDistance) {
                this.reachBottom$.next();
            }
        };
        return NelInfiniteScrollDirective;
    }());
    NelInfiniteScrollDirective.decorators = [
        { type: core.Directive, args: [{
                    selector: '[nel-infinite-scroll]'
                },] }
    ];
    NelInfiniteScrollDirective.ctorParameters = function () { return [
        { type: core.ElementRef }
    ]; };
    NelInfiniteScrollDirective.propDecorators = {
        nelDistance: [{ type: core.Input }],
        nelDisabled: [{ type: core.Input }],
        nelDelay: [{ type: core.Input }],
        nelImmediate: [{ type: core.Input }],
        nelOnReachBottom: [{ type: core.Output }]
    };

    var NelInfiniteScrollModule = /** @class */ (function () {
        function NelInfiniteScrollModule() {
        }
        return NelInfiniteScrollModule;
    }());
    NelInfiniteScrollModule.decorators = [
        { type: core.NgModule, args: [{
                    declarations: [
                        NelInfiniteScrollDirective
                    ],
                    exports: [
                        NelInfiniteScrollDirective
                    ]
                },] }
    ];

    /**
     * Generated bundle index. Do not edit.
     */

    exports.NelInfiniteScrollDirective = NelInfiniteScrollDirective;
    exports.NelInfiniteScrollModule = NelInfiniteScrollModule;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ng-element-ui-infinite-scroll.umd.js.map
