(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/platform-browser')) :
    typeof define === 'function' && define.amd ? define('ng-element-ui/layout', ['exports', '@angular/core', '@angular/platform-browser'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory((global['ng-element-ui'] = global['ng-element-ui'] || {}, global['ng-element-ui'].layout = {}), global.ng.core, global.ng.platformBrowser));
}(this, (function (exports, core, platformBrowser) { 'use strict';

    var NelColDirective = /** @class */ (function () {
        function NelColDirective(sanitizer) {
            this.sanitizer = sanitizer;
            this.nelSpan = 24;
            this.nelOffset = 0;
            this.nelXs = 0;
            this.nelSm = 0;
            this.nelMd = 0;
            this.nelLg = 0;
            this.nelXl = 0;
            this.parentGutter = 0;
        }
        NelColDirective.prototype.getClass = function () {
            var classStr = 'el-col el-col-' + this.nelSpan;
            if (this.nelOffset) {
                classStr += ' el-col-offset-' + this.nelOffset;
            }
            if (this.nelXs) {
                var span = 0;
                if (typeof this.nelXs === 'number') {
                    span = this.nelXs;
                }
                else {
                    span = this.nelXs.span;
                }
                classStr += ' el-col-xs-' + span;
            }
            if (this.nelSm) {
                var span = 0;
                if (typeof this.nelSm === 'number') {
                    span = this.nelSm;
                }
                else {
                    span = this.nelSm.span;
                }
                classStr += ' el-col-sm-' + span;
            }
            if (this.nelMd) {
                var span = 0;
                if (typeof this.nelMd === 'number') {
                    span = this.nelMd;
                }
                else {
                    span = this.nelMd.span;
                }
                classStr += ' el-col-md-' + span;
            }
            if (this.nelLg) {
                var span = 0;
                if (typeof this.nelLg === 'number') {
                    span = this.nelLg;
                }
                else {
                    span = this.nelLg.span;
                }
                classStr += ' el-col-lg-' + span;
            }
            if (this.nelXl) {
                var span = 0;
                if (typeof this.nelXl === 'number') {
                    span = this.nelXl;
                }
                else {
                    span = this.nelXl.span;
                }
                classStr += ' el-col-xl-' + span;
            }
            return classStr;
        };
        NelColDirective.prototype.gutterStyle = function () {
            var styleStr = '';
            if (this.parentGutter) {
                styleStr += "padding-left: " + this.parentGutter / 2 + "px;";
                styleStr += "padding-right: " + this.parentGutter / 2 + "px;";
            }
            return this.sanitizer.bypassSecurityTrustStyle(styleStr);
        };
        return NelColDirective;
    }());
    NelColDirective.decorators = [
        { type: core.Directive, args: [{
                    selector: '[nel-col]',
                    host: {
                        '[class]': 'getClass()',
                        '[style]': 'gutterStyle()'
                    }
                },] }
    ];
    NelColDirective.ctorParameters = function () { return [
        { type: platformBrowser.DomSanitizer }
    ]; };
    NelColDirective.propDecorators = {
        nelSpan: [{ type: core.Input }],
        nelOffset: [{ type: core.Input }],
        nelXs: [{ type: core.Input }],
        nelSm: [{ type: core.Input }],
        nelMd: [{ type: core.Input }],
        nelLg: [{ type: core.Input }],
        nelXl: [{ type: core.Input }]
    };

    var NelRowDirective = /** @class */ (function () {
        function NelRowDirective(sanitizer) {
            this.sanitizer = sanitizer;
            this.nelGutter = 0;
            this.nelType = undefined;
            this.nelJustify = 'start';
        }
        NelRowDirective.prototype.ngAfterContentInit = function () {
            var _this = this;
            if (this.nelGutter > 0) {
                this.colList.forEach(function (item) {
                    item.parentGutter = _this.nelGutter;
                });
            }
        };
        NelRowDirective.prototype.gutterStyle = function () {
            var styleStr = '';
            if (this.nelGutter) {
                styleStr += "margin-left: -" + this.nelGutter / 2 + "px;";
                styleStr += "margin-right: -" + this.nelGutter / 2 + "px;";
            }
            return this.sanitizer.bypassSecurityTrustStyle(styleStr);
        };
        return NelRowDirective;
    }());
    NelRowDirective.decorators = [
        { type: core.Directive, args: [{
                    selector: '[nel-row]',
                    host: {
                        '[class.el-row]': "true",
                        '[class.el-row--flex]': "nelType == 'flex'",
                        '[class.is-justify-end]': "nelJustify == 'end'",
                        '[class.is-justify-center]': "nelJustify == 'center'",
                        '[class.is-justify-space-around]': "nelJustify == 'space-around'",
                        '[class.is-justify-space-between]': "nelJustify == 'space-between'",
                        '[style]': 'gutterStyle()'
                    }
                },] }
    ];
    NelRowDirective.ctorParameters = function () { return [
        { type: platformBrowser.DomSanitizer }
    ]; };
    NelRowDirective.propDecorators = {
        nelGutter: [{ type: core.Input }],
        nelType: [{ type: core.Input }],
        nelJustify: [{ type: core.Input }],
        colList: [{ type: core.ContentChildren, args: [NelColDirective, { descendants: false },] }]
    };

    var NelLayoutModule = /** @class */ (function () {
        function NelLayoutModule() {
        }
        return NelLayoutModule;
    }());
    NelLayoutModule.decorators = [
        { type: core.NgModule, args: [{
                    declarations: [
                        NelRowDirective,
                        NelColDirective
                    ],
                    exports: [
                        NelRowDirective,
                        NelColDirective
                    ],
                },] }
    ];

    /**
     * Generated bundle index. Do not edit.
     */

    exports.NelColDirective = NelColDirective;
    exports.NelLayoutModule = NelLayoutModule;
    exports.NelRowDirective = NelRowDirective;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ng-element-ui-layout.umd.js.map
