(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('ng-element-ui/core/animation'), require('@angular/cdk/portal'), require('@angular/cdk/overlay'), require('@angular/common'), require('ng-element-ui/core/outlet')) :
    typeof define === 'function' && define.amd ? define('ng-element-ui/message-box', ['exports', '@angular/core', 'ng-element-ui/core/animation', '@angular/cdk/portal', '@angular/cdk/overlay', '@angular/common', 'ng-element-ui/core/outlet'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory((global['ng-element-ui'] = global['ng-element-ui'] || {}, global['ng-element-ui']['message-box'] = {}), global.ng.core, global['ng-element-ui'].core.animation, global.ng.cdk.portal, global.ng.cdk.overlay, global.ng.common, global['ng-element-ui'].core.outlet));
}(this, (function (exports, i0, animation, portal, i1, common, outlet) { 'use strict';

    var MessageBoxRef = /** @class */ (function () {
        function MessageBoxRef(type, overlay, title, content, options) {
            this.type = type;
            this.overlay = overlay;
            this.title = title;
            this.content = content;
            this.options = options;
        }
        return MessageBoxRef;
    }());

    var NelMessageBoxComponent = /** @class */ (function () {
        function NelMessageBoxComponent(messageBoxRef) {
            this.messageBoxRef = messageBoxRef;
            this.cancelButtonText = '取消';
            this.confirmButtonText = '确定';
            this.center = false;
            this.state = 'start';
            this.leaveType = '';
        }
        NelMessageBoxComponent.prototype.ngOnInit = function () {
            this.boxType = this.messageBoxRef.type;
            this.title = this.messageBoxRef.title;
            this.content = this.messageBoxRef.content;
            this.overlay = this.messageBoxRef.overlay;
            if (this.messageBoxRef.options) {
                if (this.messageBoxRef.options.cancelButtonText) {
                    this.cancelButtonText = this.messageBoxRef.options.cancelButtonText;
                }
                if (this.messageBoxRef.options.confirmButtonText) {
                    this.confirmButtonText = this.messageBoxRef.options.confirmButtonText;
                }
                if (this.messageBoxRef.options.cancel) {
                    this.cancel = this.messageBoxRef.options.cancel;
                }
                if (this.messageBoxRef.options.confirm) {
                    this.confirm = this.messageBoxRef.options.confirm;
                }
                if (this.messageBoxRef.options.type) {
                    this.type = this.messageBoxRef.options.type;
                }
                if (this.messageBoxRef.options.beforeConfirm) {
                    this.beforeConfirm = this.messageBoxRef.options.beforeConfirm;
                }
                if (this.messageBoxRef.options.center) {
                    this.center = this.messageBoxRef.options.center;
                }
            }
            this.state = 'into';
        };
        NelMessageBoxComponent.prototype.handleCancel = function (type) {
            if (!(this.boxType === 'alert' && type === 'mask_close')) {
                this.leaveType = type === 'cancel' ? 'cancel' : 'close';
                this.state = 'leave';
            }
        };
        NelMessageBoxComponent.prototype.handleConfirm = function () {
            if (this.beforeConfirm) {
                var result = this.beforeConfirm();
                if (result) {
                    this.leaveType = 'confirm';
                    this.state = 'leave';
                }
            }
            else {
                this.leaveType = 'confirm';
                this.state = 'leave';
            }
        };
        NelMessageBoxComponent.prototype.onAnimationDone = function (event) {
            if (event.toState === 'leave') {
                this.overlay.dispose();
                if (this.leaveType === 'cancel' || this.leaveType === 'close') {
                    if (this.cancel) {
                        this.cancel(this.leaveType);
                    }
                }
                else {
                    if (this.confirm) {
                        this.confirm();
                    }
                }
            }
        };
        return NelMessageBoxComponent;
    }());
    NelMessageBoxComponent.decorators = [
        { type: i0.Component, args: [{
                    selector: 'nel-message-box',
                    template: "<div class=\"el-overlay is-message-box\" (click)=\"handleCancel('mask_close')\">\r\n  <div class=\"el-message-box\" [class.el-message-box--center]=\"center\" [@messageBoxMotion]=\"state\"\r\n    (@messageBoxMotion.done)=\"onAnimationDone($event)\" (click)=\"$event.stopPropagation()\">\r\n    <div class=\"el-message-box__header\">\r\n      <div class=\"el-message-box__title\">\r\n        <div *ngIf=\"center && type\" class=\"el-message-box__status el-icon-{{type}}\"></div>\r\n        <span>\r\n          <ng-container *stringTemplate=\"title\">{{title}}</ng-container>\r\n        </span>\r\n      </div>\r\n      <button (click)=\"handleCancel('close')\" type=\"button\" class=\"el-message-box__headerbtn\" aria-label=\"Close\">\r\n        <i class=\"el-message-box__close el-icon-close\"></i>\r\n      </button>\r\n    </div>\r\n    <div class=\"el-message-box__content\">\r\n      <div class=\"el-message-box__container\">\r\n        <div *ngIf=\"!center && type\" class=\"el-message-box__status el-icon-{{type}}\"></div>\r\n        <div class=\"el-message-box__message\">\r\n          <p>\r\n            <ng-container *stringTemplate=\"content\">{{content}}</ng-container>\r\n          </p>\r\n        </div>\r\n      </div>\r\n      <div class=\"el-message-box__input\" style=\"display: none;\">\r\n        <div class=\"el-input\">\r\n          <input class=\"el-input__inner\" type=\"text\" autocomplete=\"off\" placeholder=\"\">\r\n        </div>\r\n        <div class=\"el-message-box__errormsg\" style=\"visibility: hidden;\"></div>\r\n      </div>\r\n    </div>\r\n    <div class=\"el-message-box__btns\">\r\n      <button *ngIf=\"boxType != 'alert'\" (click)=\"handleCancel('cancel')\"\r\n        class=\"el-button el-button--default el-button--small\" type=\"button\">\r\n        <span>{{cancelButtonText}}</span>\r\n      </button>\r\n      <button (click)=\"handleConfirm()\" class=\"el-button el-button--default el-button--small el-button--primary\"\r\n        type=\"button\">\r\n        <span>{{confirmButtonText}}</span>\r\n      </button>\r\n    </div>\r\n  </div>\r\n</div>\r\n",
                    animations: [animation.messageBoxMotion]
                },] }
    ];
    NelMessageBoxComponent.ctorParameters = function () { return [
        { type: MessageBoxRef }
    ]; };

    var NelMessageBoxService = /** @class */ (function () {
        function NelMessageBoxService(overlay, injector) {
            this.overlay = overlay;
            this.injector = injector;
        }
        NelMessageBoxService.prototype.blank = function (title, content, options) {
            return this.show('blank', title, content, options);
        };
        NelMessageBoxService.prototype.alert = function (title, content, options) {
            return this.show('alert', title, content, options);
        };
        NelMessageBoxService.prototype.confirm = function (title, content, options) {
            return this.show('confirm', title, content, options);
        };
        NelMessageBoxService.prototype.show = function (type, title, content, options) {
            var overlayRef = this.overlay.create();
            var messageBoxRef = new MessageBoxRef(type, overlayRef, title, content, options);
            var injector = this.createInjector(messageBoxRef, this.injector);
            overlayRef.attach(new portal.ComponentPortal(NelMessageBoxComponent, null, injector));
            return messageBoxRef;
        };
        NelMessageBoxService.prototype.createInjector = function (ref, inj) {
            return i0.Injector.create({
                parent: inj,
                providers: [{ provide: MessageBoxRef, useValue: ref }]
            });
        };
        return NelMessageBoxService;
    }());
    NelMessageBoxService.ɵprov = i0.ɵɵdefineInjectable({ factory: function NelMessageBoxService_Factory() { return new NelMessageBoxService(i0.ɵɵinject(i1.Overlay), i0.ɵɵinject(i0.INJECTOR)); }, token: NelMessageBoxService, providedIn: "root" });
    NelMessageBoxService.decorators = [
        { type: i0.Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];
    NelMessageBoxService.ctorParameters = function () { return [
        { type: i1.Overlay },
        { type: i0.Injector }
    ]; };

    var NelMessageBoxModule = /** @class */ (function () {
        function NelMessageBoxModule() {
        }
        return NelMessageBoxModule;
    }());
    NelMessageBoxModule.decorators = [
        { type: i0.NgModule, args: [{
                    declarations: [
                        NelMessageBoxComponent
                    ],
                    exports: [
                        NelMessageBoxComponent
                    ],
                    imports: [
                        common.CommonModule,
                        outlet.NelOutletModule
                    ],
                    providers: [
                        NelMessageBoxService
                    ]
                },] }
    ];

    /**
     * Generated bundle index. Do not edit.
     */

    exports.NelMessageBoxComponent = NelMessageBoxComponent;
    exports.NelMessageBoxModule = NelMessageBoxModule;
    exports.NelMessageBoxService = NelMessageBoxService;
    exports.ɵa = MessageBoxRef;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ng-element-ui-message-box.umd.js.map
