(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('ng-element-ui/core/animation'), require('@angular/cdk/portal'), require('@angular/cdk/overlay'), require('rxjs'), require('@angular/common'), require('ng-element-ui/core/outlet')) :
    typeof define === 'function' && define.amd ? define('ng-element-ui/notification', ['exports', '@angular/core', 'ng-element-ui/core/animation', '@angular/cdk/portal', '@angular/cdk/overlay', 'rxjs', '@angular/common', 'ng-element-ui/core/outlet'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory((global['ng-element-ui'] = global['ng-element-ui'] || {}, global['ng-element-ui'].notification = {}), global.ng.core, global['ng-element-ui'].core.animation, global.ng.cdk.portal, global.ng.cdk.overlay, global.rxjs, global.ng.common, global['ng-element-ui'].core.outlet));
}(this, (function (exports, i0, animation, portal, i1, rxjs, common, outlet) { 'use strict';

    var NelNotificationRef = /** @class */ (function () {
        function NelNotificationRef(type, id, leave, overlay, title, content, options) {
            this.type = type;
            this.id = id;
            this.leave = leave;
            this.overlay = overlay;
            this.title = title;
            this.content = content;
            this.options = options;
            this.height = 84;
            this.position = 'topRight';
            this.top = 0;
            this.bottom = 0;
            this.componentInstance = null;
        }
        NelNotificationRef.prototype.close = function () {
            this.componentInstance.state = 'done';
        };
        return NelNotificationRef;
    }());

    var NelNotificationComponent = /** @class */ (function () {
        function NelNotificationComponent(notificationRef) {
            this.notificationRef = notificationRef;
            this.id = 0;
            this.top = 16;
            this.bottom = 16;
            this.showClose = true;
            this.duration = 3000;
            this.state = '';
        }
        NelNotificationComponent.prototype.ngOnDestroy = function () {
            if (this.timer) {
                clearTimeout(this.timer);
            }
        };
        NelNotificationComponent.prototype.ngOnInit = function () {
            this.type = this.notificationRef.type;
            this.id = this.notificationRef.id;
            this.position = this.notificationRef.position;
            this.top = this.notificationRef.top;
            this.bottom = this.notificationRef.bottom;
            this.title = this.notificationRef.title;
            this.content = this.notificationRef.content;
            this.overlay = this.notificationRef.overlay;
            if (this.notificationRef.options) {
                if (this.notificationRef.options.duration !== undefined) {
                    this.duration = this.notificationRef.options.duration;
                }
                if (this.notificationRef.options.showClose !== undefined) {
                    this.showClose = this.notificationRef.options.showClose;
                }
                if (this.notificationRef.options.onClose) {
                    this.onClose = this.notificationRef.options.onClose;
                }
            }
            if (this.position === 'topRight' || this.position === 'bottomRight') {
                this.state = 'rightInto';
            }
            else {
                this.state = 'leftInto';
            }
            this.initTimer();
        };
        NelNotificationComponent.prototype.ngAfterViewInit = function () {
            this.notificationRef.height = this.notificationEle.nativeElement.offsetHeight;
        };
        NelNotificationComponent.prototype.initTimer = function () {
            var _this = this;
            if (this.duration > 0) {
                this.timer = setTimeout(function () {
                    _this.state = 'leave';
                }, this.duration);
            }
        };
        NelNotificationComponent.prototype.onAnimationStart = function (event) {
            if (event.toState === 'leave') {
                clearTimeout(this.timer);
                this.notificationRef.leave.next({ id: this.id, position: this.position });
            }
        };
        NelNotificationComponent.prototype.onAnimationDone = function (event) {
            if (event.toState === 'leave') {
                this.overlay.dispose();
                if (this.onClose) {
                    this.onClose();
                }
            }
        };
        NelNotificationComponent.prototype.mouseenter = function () {
            if (this.timer) {
                clearTimeout(this.timer);
            }
        };
        NelNotificationComponent.prototype.mouseleave = function () {
            this.initTimer();
        };
        NelNotificationComponent.prototype.close = function () {
            if (this.timer) {
                clearTimeout(this.timer);
            }
            this.state = 'leave';
        };
        return NelNotificationComponent;
    }());
    NelNotificationComponent.decorators = [
        { type: i0.Component, args: [{
                    selector: 'nel-notification',
                    template: "<div #notificationEle class=\"el-notification\" [class.right]=\"position == 'topRight' || position == 'bottomRight'\"\r\n  [class.left]=\"position == 'topLeft' || position == 'bottomLeft'\" role=\"alert\" style=\"top: 16px\"\r\n  [style.top]=\"top ? top + 'px' : ''\" [style.bottom]=\"bottom ? bottom + 'px' : ''\" [@notificationMotion]=\"state\"\r\n  (@notificationMotion.start)=\"onAnimationStart($event)\" (@notificationMotion.done)=\"onAnimationDone($event)\"\r\n  (mouseenter)=\"mouseenter()\" (mouseleave)=\"mouseleave()\">\r\n  <i *ngIf=\"type != 'blank'\" class=\"el-notification__icon el-icon-{{type}}\"></i>\r\n  <div class=\"el-notification__group\">\r\n    <h2 class=\"el-notification__title\">\r\n      <ng-container *stringTemplate=\"title\">{{title}}</ng-container>\r\n    </h2>\r\n    <div class=\"el-notification__content\">\r\n      <ng-container *stringTemplate=\"content\">{{content}}</ng-container>\r\n    </div>\r\n    <div *ngIf=\"showClose\" (click)=\"close()\" class=\"el-notification__closeBtn el-icon-close\"></div>\r\n  </div>\r\n</div>\r\n",
                    animations: [animation.notificationMotion]
                },] }
    ];
    NelNotificationComponent.ctorParameters = function () { return [
        { type: NelNotificationRef }
    ]; };
    NelNotificationComponent.propDecorators = {
        notificationEle: [{ type: i0.ViewChild, args: ['notificationEle', { static: false },] }]
    };

    var NelNotificationService = /** @class */ (function () {
        function NelNotificationService(overlay, injector) {
            this.overlay = overlay;
            this.injector = injector;
            this.notificationId = 0;
            this.leave = new rxjs.Subject();
            this.notificationRefList = {
                topRight: [],
                bottomRight: [],
                topLeft: [],
                bottomLeft: []
            };
            this._handlerLeave();
        }
        NelNotificationService.prototype.blank = function (title, content, options) {
            return this.show('blank', title, content, options);
        };
        NelNotificationService.prototype.success = function (title, content, options) {
            return this.show('success', title, content, options);
        };
        NelNotificationService.prototype.warning = function (title, content, options) {
            return this.show('warning', title, content, options);
        };
        NelNotificationService.prototype.info = function (title, content, options) {
            return this.show('info', title, content, options);
        };
        NelNotificationService.prototype.error = function (title, content, options) {
            return this.show('error', title, content, options);
        };
        NelNotificationService.prototype.show = function (type, title, content, options) {
            this.notificationId++;
            var overlayRef = this.overlay.create();
            var notificationRef = new NelNotificationRef(type, this.notificationId, this.leave, overlayRef, title, content, options);
            var injector = this.createInjector(notificationRef, this.injector);
            var componentRef = overlayRef.attach(new portal.ComponentPortal(NelNotificationComponent, null, injector));
            // 根据notification，获取下一个notification的top
            var top = 16;
            var bottom = 16;
            var key = 'topRight';
            if (options) {
                if (options.offset) {
                    top += options.offset;
                    bottom += options.offset;
                }
                if (options.position) {
                    switch (options.position) {
                        case 'bottom-right':
                            key = 'bottomRight';
                            break;
                        case 'top-left':
                            key = 'topLeft';
                            break;
                        case 'bottom-left':
                            key = 'bottomLeft';
                            break;
                    }
                }
            }
            if (key === 'topRight' || key === 'topLeft') {
                bottom = 0;
                this.notificationRefList[key].forEach(function (item) {
                    top += item.height + 16;
                });
            }
            else {
                top = 0;
                this.notificationRefList[key].forEach(function (item) {
                    bottom += item.height + 16;
                });
            }
            this.notificationRefList[key].push(notificationRef);
            notificationRef.position = key;
            notificationRef.top = top;
            notificationRef.bottom = bottom;
            notificationRef.componentInstance = componentRef.instance;
            return notificationRef;
        };
        NelNotificationService.prototype.createInjector = function (ref, inj) {
            return i0.Injector.create({
                parent: inj,
                providers: [{ provide: NelNotificationRef, useValue: ref }]
            });
        };
        NelNotificationService.prototype._handlerLeave = function () {
            var _this = this;
            this.leave.subscribe(function (val) {
                var componentIndex = _this.notificationRefList[val.position].findIndex(function (item) { return item.id === val.id; });
                if (componentIndex > -1) {
                    var height = _this.notificationRefList[val.position][componentIndex].height;
                    if (componentIndex !== _this.notificationRefList[val.position].length - 1) {
                        for (var i = componentIndex + 1; i < _this.notificationRefList[val.position].length; i++) {
                            _this.notificationRefList[val.position][i].componentInstance.top -= height + 16;
                        }
                    }
                    _this.notificationRefList[val.position].splice(componentIndex, 1);
                }
            });
        };
        return NelNotificationService;
    }());
    NelNotificationService.ɵprov = i0.ɵɵdefineInjectable({ factory: function NelNotificationService_Factory() { return new NelNotificationService(i0.ɵɵinject(i1.Overlay), i0.ɵɵinject(i0.INJECTOR)); }, token: NelNotificationService, providedIn: "root" });
    NelNotificationService.decorators = [
        { type: i0.Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];
    NelNotificationService.ctorParameters = function () { return [
        { type: i1.Overlay },
        { type: i0.Injector }
    ]; };

    var NelNotificationModule = /** @class */ (function () {
        function NelNotificationModule() {
        }
        return NelNotificationModule;
    }());
    NelNotificationModule.decorators = [
        { type: i0.NgModule, args: [{
                    declarations: [
                        NelNotificationComponent
                    ],
                    exports: [
                        NelNotificationComponent
                    ],
                    imports: [
                        common.CommonModule,
                        i1.OverlayModule,
                        outlet.NelOutletModule
                    ],
                    providers: [
                        NelNotificationService
                    ]
                },] }
    ];

    /**
     * Generated bundle index. Do not edit.
     */

    exports.NelNotificationComponent = NelNotificationComponent;
    exports.NelNotificationModule = NelNotificationModule;
    exports.NelNotificationService = NelNotificationService;
    exports.ɵa = NelNotificationRef;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ng-element-ui-notification.umd.js.map
