(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/common'), require('@angular/cdk/overlay'), require('ng-element-ui/button'), require('ng-element-ui/icon')) :
    typeof define === 'function' && define.amd ? define('ng-element-ui/popconfirm', ['exports', '@angular/core', '@angular/common', '@angular/cdk/overlay', 'ng-element-ui/button', 'ng-element-ui/icon'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory((global['ng-element-ui'] = global['ng-element-ui'] || {}, global['ng-element-ui'].popconfirm = {}), global.ng.core, global.ng.common, global.ng.cdk.overlay, global['ng-element-ui'].button, global['ng-element-ui'].icon));
}(this, (function (exports, core, common, overlay, button, icon) { 'use strict';

    var NelPopconfirmComponent = /** @class */ (function () {
        function NelPopconfirmComponent() {
            this.isOpen = false;
            this.arrowLeft = '';
            this.arrowRight = '';
            this.arrowTop = '';
            this.arrowBottom = '';
            this.transform = '';
        }
        NelPopconfirmComponent.prototype.close = function () {
            this.isOpen = false;
        };
        NelPopconfirmComponent.prototype.cancel = function () {
            this.isOpen = false;
            if (this.onCancel) {
                this.onCancel.emit();
            }
        };
        NelPopconfirmComponent.prototype.confirm = function () {
            this.isOpen = false;
            if (this.onConfirm) {
                this.onConfirm.emit();
            }
        };
        return NelPopconfirmComponent;
    }());
    NelPopconfirmComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'nel-popconfirm',
                    template: "<ng-template cdkConnectedOverlay [cdkConnectedOverlayOrigin]=\"trigger\" [cdkConnectedOverlayOpen]=\"isOpen\"\r\n  [cdkConnectedOverlayPositions]=\"positionStrategy\" (overlayOutsideClick)=\"close()\">\r\n  <div class=\"el-popover el-popper is-light\">\r\n    <div class=\"el-popconfirm\">\r\n      <p class=\"el-popconfirm__main\">\r\n        <i *ngIf=\"!hideIcon\" nel-icon [nelType]=\"icon\" class=\"el-popconfirm__icon\" [style.color]=\"iconColor\"></i>\r\n        {{title}}\r\n      </p>\r\n      <div class=\"el-popconfirm__action\">\r\n        <button nel-button [nelType]=\"cancelButtonType\" [nelSize]=\"'mini'\" (click)=\"cancel()\">\r\n          {{cancelButtonText}}\r\n        </button>\r\n        <button nel-button [nelType]=\"confirmButtonType\" [nelSize]=\"'mini'\" (click)=\"confirm()\">\r\n          {{confirmButtonText}}\r\n        </button>\r\n      </div>\r\n    </div>\r\n    <div class=\"el-popper__arrow\" [style.left]=\"arrowLeft\" [style.right]=\"arrowRight\" [style.top]=\"arrowTop\"\r\n      [style.bottom]=\"arrowBottom\" [style.transform]=\"transform\"></div>\r\n  </div>\r\n</ng-template>\r\n"
                },] }
    ];

    var NelPopconfirmDirective = /** @class */ (function () {
        function NelPopconfirmDirective(hostView, elementRef, resolver, renderer) {
            this.hostView = hostView;
            this.elementRef = elementRef;
            this.resolver = resolver;
            this.renderer = renderer;
            this.nelPlacement = 'bottom';
            this.nelConfirmButtonText = '确认';
            this.nelCancelButtonText = '取消';
            this.nelConfirmButtonType = 'primary';
            this.nelCancelButtonType = 'text';
            this.nelIcon = 'question';
            this.nelIconColor = '#f90';
            this.nelHideIcon = false;
            this.nelOnCancel = new core.EventEmitter();
            this.nelOnConfirm = new core.EventEmitter();
            this.componentFactory = this.resolver.resolveComponentFactory(NelPopconfirmComponent);
            var componentRef = this.hostView.createComponent(this.componentFactory);
            this.component = componentRef.instance;
            this.renderer.removeChild(this.renderer.parentNode(this.elementRef.nativeElement), componentRef.location.nativeElement);
        }
        NelPopconfirmDirective.prototype.onClick = function () {
            this.show();
        };
        NelPopconfirmDirective.prototype.show = function () {
            var position = {
                originX: 'start',
                originY: 'top',
                overlayX: 'start',
                overlayY: 'bottom',
                offsetX: 0,
                offsetY: 0,
            };
            var arrowLeft = '';
            var arrowRight = '';
            var arrowTop = '';
            var arrowBottom = '';
            var transform = '';
            switch (this.nelPlacement) {
                case 'top-start':
                    position.originX = 'start';
                    position.originY = 'top';
                    position.overlayX = 'start';
                    position.overlayY = 'bottom';
                    position.offsetY = -10;
                    arrowLeft = '0';
                    transform = 'translate(30px, 5px)';
                    break;
                case 'top':
                    position.originX = 'center';
                    position.originY = 'top';
                    position.overlayX = 'center';
                    position.overlayY = 'bottom';
                    position.offsetY = -10;
                    arrowLeft = '50%';
                    transform = 'translate(-50%, 5px)';
                    break;
                case 'top-end':
                    position.originX = 'end';
                    position.originY = 'top';
                    position.overlayX = 'end';
                    position.overlayY = 'bottom';
                    position.offsetY = -10;
                    arrowLeft = '50%';
                    transform = 'translate(30px, 5px)';
                    break;
                case 'bottom-start':
                    position.originX = 'start';
                    position.originY = 'bottom';
                    position.overlayX = 'start';
                    position.overlayY = 'top';
                    position.offsetY = 10;
                    arrowLeft = '0';
                    arrowTop = '-10px';
                    transform = 'translate(30px, 5px)';
                    break;
                case 'bottom':
                    position.originX = 'center';
                    position.originY = 'bottom';
                    position.overlayX = 'center';
                    position.overlayY = 'top';
                    position.offsetY = 10;
                    arrowLeft = '50%';
                    arrowTop = '-10px';
                    transform = 'translate(-50%, 5px)';
                    break;
                case 'bottom-end':
                    position.originX = 'end';
                    position.originY = 'bottom';
                    position.overlayX = 'end';
                    position.overlayY = 'top';
                    position.offsetY = 10;
                    arrowLeft = '50%';
                    arrowTop = '-10px';
                    transform = 'translate(30px, 5px)';
                    break;
                case 'left-start':
                    position.originX = 'start';
                    position.originY = 'top';
                    position.overlayX = 'end';
                    position.overlayY = 'top';
                    position.offsetX = -10;
                    arrowRight = '0';
                    arrowTop = '0';
                    transform = 'translate(5px, 15px)';
                    break;
                case 'left':
                    position.originX = 'start';
                    position.originY = 'center';
                    position.overlayX = 'end';
                    position.overlayY = 'center';
                    position.offsetX = -10;
                    arrowRight = '0';
                    arrowTop = '50%';
                    transform = 'translate(5px, -50%)';
                    break;
                case 'left-end':
                    position.originX = 'start';
                    position.originY = 'bottom';
                    position.overlayX = 'end';
                    position.overlayY = 'bottom';
                    position.offsetX = -10;
                    arrowRight = '0';
                    arrowBottom = '0';
                    transform = 'translate(5px, -15px)';
                    break;
                case 'right-start':
                    position.originX = 'end';
                    position.originY = 'top';
                    position.overlayX = 'start';
                    position.overlayY = 'top';
                    position.offsetX = 10;
                    arrowLeft = '0';
                    arrowTop = '0';
                    transform = 'translate(-5px, 15px)';
                    break;
                case 'right':
                    position.originX = 'end';
                    position.originY = 'center';
                    position.overlayX = 'start';
                    position.overlayY = 'center';
                    position.offsetX = 10;
                    arrowLeft = '0';
                    arrowTop = '50%';
                    transform = 'translate(-5px, -50%)';
                    break;
                case 'right-end':
                    position.originX = 'end';
                    position.originY = 'bottom';
                    position.overlayX = 'start';
                    position.overlayY = 'bottom';
                    position.offsetX = 10;
                    arrowLeft = '0';
                    arrowBottom = '0';
                    transform = 'translate(-5px, -15px)';
                    break;
            }
            if (this.component) {
                this.component.title = this.nelPopconfirmTitle;
                this.component.onCancel = this.nelOnCancel;
                this.component.onConfirm = this.nelOnConfirm;
                this.component.confirmButtonText = this.nelConfirmButtonText;
                this.component.cancelButtonText = this.nelCancelButtonText;
                this.component.confirmButtonType = this.nelConfirmButtonType;
                this.component.cancelButtonType = this.nelCancelButtonType;
                this.component.icon = this.nelIcon;
                this.component.iconColor = this.nelIconColor;
                this.component.hideIcon = this.nelHideIcon;
                this.component.trigger = { elementRef: this.elementRef };
                this.component.isOpen = true;
                this.component.positionStrategy = [position];
                this.component.arrowLeft = arrowLeft;
                this.component.arrowRight = arrowRight;
                this.component.arrowTop = arrowTop;
                this.component.arrowBottom = arrowBottom;
                this.component.transform = transform;
            }
        };
        return NelPopconfirmDirective;
    }());
    NelPopconfirmDirective.decorators = [
        { type: core.Directive, args: [{
                    selector: '[nel-popconfirm]'
                },] }
    ];
    NelPopconfirmDirective.ctorParameters = function () { return [
        { type: core.ViewContainerRef },
        { type: core.ElementRef },
        { type: core.ComponentFactoryResolver },
        { type: core.Renderer2 }
    ]; };
    NelPopconfirmDirective.propDecorators = {
        nelPopconfirmTitle: [{ type: core.Input }],
        nelPlacement: [{ type: core.Input }],
        nelConfirmButtonText: [{ type: core.Input }],
        nelCancelButtonText: [{ type: core.Input }],
        nelConfirmButtonType: [{ type: core.Input }],
        nelCancelButtonType: [{ type: core.Input }],
        nelIcon: [{ type: core.Input }],
        nelIconColor: [{ type: core.Input }],
        nelHideIcon: [{ type: core.Input }],
        nelOnCancel: [{ type: core.Output }],
        nelOnConfirm: [{ type: core.Output }],
        onClick: [{ type: core.HostListener, args: ['click', ['$event.target'],] }]
    };

    var NelPopconfirmModule = /** @class */ (function () {
        function NelPopconfirmModule() {
        }
        return NelPopconfirmModule;
    }());
    NelPopconfirmModule.decorators = [
        { type: core.NgModule, args: [{
                    declarations: [
                        NelPopconfirmDirective,
                        NelPopconfirmComponent
                    ],
                    exports: [
                        NelPopconfirmDirective,
                        NelPopconfirmComponent
                    ],
                    imports: [
                        common.CommonModule,
                        overlay.OverlayModule,
                        button.NelButtonModule,
                        icon.NelIconModule
                    ]
                },] }
    ];

    /**
     * Generated bundle index. Do not edit.
     */

    exports.NelPopconfirmDirective = NelPopconfirmDirective;
    exports.NelPopconfirmModule = NelPopconfirmModule;
    exports.ɵa = NelPopconfirmComponent;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ng-element-ui-popconfirm.umd.js.map
