(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('ng-element-ui/core/animation'), require('@angular/cdk/portal'), require('@angular/cdk/overlay'), require('ng-element-ui/core/outlet')) :
    typeof define === 'function' && define.amd ? define('ng-element-ui/tooltip', ['exports', '@angular/core', 'ng-element-ui/core/animation', '@angular/cdk/portal', '@angular/cdk/overlay', 'ng-element-ui/core/outlet'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory((global['ng-element-ui'] = global['ng-element-ui'] || {}, global['ng-element-ui'].tooltip = {}), global.ng.core, global['ng-element-ui'].core.animation, global.ng.cdk.portal, global.ng.cdk.overlay, global['ng-element-ui'].core.outlet));
}(this, (function (exports, core, animation, portal, overlay, outlet) { 'use strict';

    var NelTooltipComponent = /** @class */ (function () {
        function NelTooltipComponent() {
            this.arrowLeft = '';
            this.arrowRight = '';
            this.arrowTop = '';
            this.arrowBottom = '';
            this.transform = '';
            this.effect = 'dark';
        }
        return NelTooltipComponent;
    }());
    NelTooltipComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'nel-tooltip',
                    template: "<div class=\"el-popper is-{{effect}}\">\r\n  <ng-container *stringTemplate=\"content\">{{content}}</ng-container>\r\n  <div class=\"el-popper__arrow\" [style.left]=\"arrowLeft\" [style.right]=\"arrowRight\" [style.top]=\"arrowTop\"\r\n    [style.bottom]=\"arrowBottom\" [style.transform]=\"transform\"></div>\r\n</div>\r\n",
                    changeDetection: core.ChangeDetectionStrategy.OnPush,
                    animations: [animation.fadeMotion]
                },] }
    ];

    var NelTooltipDirective = /** @class */ (function () {
        function NelTooltipDirective(overlay, overlayPositionBuilder, elementRef) {
            this.overlay = overlay;
            this.overlayPositionBuilder = overlayPositionBuilder;
            this.elementRef = elementRef;
            this.nelPlacement = 'bottom';
            this.nelEffect = 'dark';
            this.disabled = false;
        }
        Object.defineProperty(NelTooltipDirective.prototype, "nelDisabled", {
            set: function (value) {
                this.disabled = value;
                if (value) {
                    this.hide();
                }
            },
            enumerable: false,
            configurable: true
        });
        NelTooltipDirective.prototype.ngOnInit = function () {
            // if (this.nelPlacement === 'bottom') {
            //   this.show();
            // }
        };
        NelTooltipDirective.prototype.onMouseenter = function () {
            if (!this.disabled) {
                this.show();
            }
        };
        NelTooltipDirective.prototype.onMouseleave = function () {
            this.hide();
        };
        NelTooltipDirective.prototype.show = function () {
            var position = {
                originX: 'start',
                originY: 'top',
                overlayX: 'start',
                overlayY: 'bottom',
                offsetX: 0,
                offsetY: 0
            };
            var arrowLeft = '';
            var arrowRight = '';
            var arrowTop = '';
            var arrowBottom = '';
            var transform = '';
            switch (this.nelPlacement) {
                case 'top-start':
                    position.originX = 'start';
                    position.originY = 'top';
                    position.overlayX = 'start';
                    position.overlayY = 'bottom';
                    position.offsetY = -10;
                    arrowLeft = '0';
                    transform = 'translate(30px, 5px)';
                    break;
                case 'top':
                    position.originX = 'center';
                    position.originY = 'top';
                    position.overlayX = 'center';
                    position.overlayY = 'bottom';
                    position.offsetY = -10;
                    arrowLeft = '50%';
                    transform = 'translate(-50%, 5px)';
                    break;
                case 'top-end':
                    position.originX = 'end';
                    position.originY = 'top';
                    position.overlayX = 'end';
                    position.overlayY = 'bottom';
                    position.offsetY = -10;
                    arrowLeft = '50%';
                    transform = 'translate(30px, 5px)';
                    break;
                case 'bottom-start':
                    position.originX = 'start';
                    position.originY = 'bottom';
                    position.overlayX = 'start';
                    position.overlayY = 'top';
                    position.offsetY = 10;
                    arrowLeft = '0';
                    arrowTop = '-10px';
                    transform = 'translate(30px, 5px)';
                    break;
                case 'bottom':
                    position.originX = 'center';
                    position.originY = 'bottom';
                    position.overlayX = 'center';
                    position.overlayY = 'top';
                    position.offsetY = 10;
                    arrowLeft = '50%';
                    arrowTop = '-10px';
                    transform = 'translate(-50%, 5px)';
                    break;
                case 'bottom-end':
                    position.originX = 'end';
                    position.originY = 'bottom';
                    position.overlayX = 'end';
                    position.overlayY = 'top';
                    position.offsetY = 10;
                    arrowLeft = '50%';
                    arrowTop = '-10px';
                    transform = 'translate(30px, 5px)';
                    break;
                case 'left-start':
                    position.originX = 'start';
                    position.originY = 'top';
                    position.overlayX = 'end';
                    position.overlayY = 'top';
                    position.offsetX = -10;
                    arrowRight = '0';
                    arrowTop = '0';
                    transform = 'translate(5px, 15px)';
                    break;
                case 'left':
                    position.originX = 'start';
                    position.originY = 'center';
                    position.overlayX = 'end';
                    position.overlayY = 'center';
                    position.offsetX = -10;
                    arrowRight = '0';
                    arrowTop = '50%';
                    transform = 'translate(5px, -50%)';
                    break;
                case 'left-end':
                    position.originX = 'start';
                    position.originY = 'bottom';
                    position.overlayX = 'end';
                    position.overlayY = 'bottom';
                    position.offsetX = -10;
                    arrowRight = '0';
                    arrowBottom = '0';
                    transform = 'translate(5px, -15px)';
                    break;
                case 'right-start':
                    position.originX = 'end';
                    position.originY = 'top';
                    position.overlayX = 'start';
                    position.overlayY = 'top';
                    position.offsetX = 10;
                    arrowLeft = '0';
                    arrowTop = '0';
                    transform = 'translate(-5px, 15px)';
                    break;
                case 'right':
                    position.originX = 'end';
                    position.originY = 'center';
                    position.overlayX = 'start';
                    position.overlayY = 'center';
                    position.offsetX = 10;
                    arrowLeft = '0';
                    arrowTop = '50%';
                    transform = 'translate(-5px, -50%)';
                    break;
                case 'right-end':
                    position.originX = 'end';
                    position.originY = 'bottom';
                    position.overlayX = 'start';
                    position.overlayY = 'bottom';
                    position.offsetX = 10;
                    arrowLeft = '0';
                    arrowBottom = '0';
                    transform = 'translate(-5px, -15px)';
                    break;
            }
            var positionStrategy = this.overlayPositionBuilder
                .flexibleConnectedTo(this.elementRef)
                .withPositions([position]);
            this.overlayRef = this.overlay.create({ positionStrategy: positionStrategy });
            if (this.overlayRef) {
                var tooltipRef = this.overlayRef.attach(new portal.ComponentPortal(NelTooltipComponent));
                if (this.nelContent) {
                    tooltipRef.instance.content = this.nelContent;
                    tooltipRef.instance.effect = this.nelEffect;
                    tooltipRef.instance.arrowLeft = arrowLeft;
                    tooltipRef.instance.arrowRight = arrowRight;
                    tooltipRef.instance.arrowTop = arrowTop;
                    tooltipRef.instance.arrowBottom = arrowBottom;
                    tooltipRef.instance.transform = transform;
                }
            }
        };
        NelTooltipDirective.prototype.hide = function () {
            var _a;
            (_a = this.overlayRef) === null || _a === void 0 ? void 0 : _a.detach();
        };
        return NelTooltipDirective;
    }());
    NelTooltipDirective.decorators = [
        { type: core.Directive, args: [{
                    selector: '[nel-tooltip]',
                },] }
    ];
    NelTooltipDirective.ctorParameters = function () { return [
        { type: overlay.Overlay },
        { type: overlay.OverlayPositionBuilder },
        { type: core.ElementRef }
    ]; };
    NelTooltipDirective.propDecorators = {
        nelContent: [{ type: core.Input }],
        nelPlacement: [{ type: core.Input }],
        nelEffect: [{ type: core.Input }],
        nelDisabled: [{ type: core.Input }],
        onMouseenter: [{ type: core.HostListener, args: ['mouseenter', ['$event.target'],] }],
        onMouseleave: [{ type: core.HostListener, args: ['mouseleave', ['$event.target'],] }]
    };

    var NelTooltipModule = /** @class */ (function () {
        function NelTooltipModule() {
        }
        return NelTooltipModule;
    }());
    NelTooltipModule.decorators = [
        { type: core.NgModule, args: [{
                    declarations: [
                        NelTooltipComponent,
                        NelTooltipDirective
                    ],
                    exports: [
                        NelTooltipComponent,
                        NelTooltipDirective
                    ],
                    entryComponents: [
                        NelTooltipComponent
                    ],
                    imports: [
                        overlay.OverlayModule,
                        outlet.NelOutletModule
                    ]
                },] }
    ];

    /**
     * Generated bundle index. Do not edit.
     */

    exports.NelTooltipComponent = NelTooltipComponent;
    exports.NelTooltipDirective = NelTooltipDirective;
    exports.NelTooltipModule = NelTooltipModule;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ng-element-ui-tooltip.umd.js.map
