import { OnInit, OnDestroy, Renderer2, ElementRef } from '@angular/core';
import { NelDropdownMenuComponent } from './dropdown-menu.component';
export declare type TriggerType = 'click' | 'contextmenu' | 'hover';
export declare type SizeType = 'medium' | 'small' | 'mini';
export declare class NelDropdownDirective implements OnInit, OnDestroy {
    private elementRef;
    private renderer;
    nelDropdownTrigger: TriggerType;
    nelDropdownMenu?: NelDropdownMenuComponent;
    nelHideOnClick: boolean;
    nelDropdownSize?: SizeType;
    nelMaxHeight?: string | number;
    component?: NelDropdownMenuComponent;
    protected readonly triggerDisposables: Array<() => void>;
    constructor(elementRef: ElementRef, renderer: Renderer2);
    ngOnDestroy(): void;
    ngOnInit(): void;
    trigger(): void;
    private removeTriggerListeners;
    show($event: MouseEvent): void;
    hide(): void;
}
