import { __decorate } from 'tslib';
import { EventEmitter, Component, Input, Output, NgModule } from '@angular/core';
import { InputBoolean } from 'ng-element-ui/core/utils';
import { CommonModule } from '@angular/common';
import { NelIconModule } from 'ng-element-ui/icon';
import { NelOutletModule } from 'ng-element-ui/core/outlet';

class NelAlertComponent {
    constructor() {
        this.nelType = 'info';
        this.nelEffect = 'light';
        this.nelClosable = true;
        this.nelCloseText = null;
        this.nelShowIcon = false;
        this.nelCenter = false;
        this.nelOnClose = new EventEmitter();
        this.hide = false;
    }
    close() {
        this.nelOnClose.emit(true);
        this.hide = true;
    }
}
NelAlertComponent.decorators = [
    { type: Component, args: [{
                selector: 'nel-alert',
                template: "<div *ngIf=\"!hide\" class=\"el-alert el-alert--{{nelType}} is-{{nelEffect}} {{nelCenter ? 'is-center' : ''}}\"\r\n  role=\"alert\">\r\n  <i *ngIf=\"nelShowIcon\" nel-icon [nelType]=\"nelType\" class=\"el-alert__icon {{nelDescription ? 'is-big' : ''}}\"></i>\r\n  <div class=\"el-alert__content\">\r\n    <span class=\"el-alert__title {{nelDescription ? 'is-bold' : ''}}\">\r\n      <ng-container *stringTemplate=\"nelTitle\">{{nelTitle}}</ng-container>\r\n    </span>\r\n    <p *ngIf=\"nelDescription\" class=\"el-alert__description\">\r\n      <ng-container *stringTemplate=\"nelDescription\">{{nelDescription}}</ng-container>\r\n    </p>\r\n    <ng-container *ngIf=\"nelClosable\">\r\n      <i *ngIf=\"!nelCloseText; else closeTextTpl\" nel-icon [nelType]=\"'close'\" class=\"el-alert__closebtn\"\r\n        (click)=\"close()\"></i>\r\n      <ng-template #closeTextTpl>\r\n        <i class=\"el-alert__closebtn is-customed\" (click)=\"close()\">\u77E5\u9053\u4E86</i>\r\n      </ng-template>\r\n    </ng-container>\r\n  </div>\r\n</div>\r\n"
            },] }
];
NelAlertComponent.ctorParameters = () => [];
NelAlertComponent.propDecorators = {
    nelTitle: [{ type: Input }],
    nelType: [{ type: Input }],
    nelEffect: [{ type: Input }],
    nelClosable: [{ type: Input }],
    nelCloseText: [{ type: Input }],
    nelShowIcon: [{ type: Input }],
    nelCenter: [{ type: Input }],
    nelDescription: [{ type: Input }],
    nelOnClose: [{ type: Output }]
};
__decorate([
    InputBoolean()
], NelAlertComponent.prototype, "nelShowIcon", void 0);
__decorate([
    InputBoolean()
], NelAlertComponent.prototype, "nelCenter", void 0);

class NelAlertModule {
}
NelAlertModule.decorators = [
    { type: NgModule, args: [{
                declarations: [
                    NelAlertComponent
                ],
                exports: [
                    NelAlertComponent
                ],
                imports: [
                    CommonModule,
                    NelIconModule,
                    NelOutletModule
                ]
            },] }
];

/**
 * Generated bundle index. Do not edit.
 */

export { NelAlertComponent, NelAlertModule };
//# sourceMappingURL=ng-element-ui-alert.js.map
