import { __decorate } from 'tslib';
import { Component, Input, NgModule } from '@angular/core';
import { InputBoolean } from 'ng-element-ui/core/utils';
import { CommonModule } from '@angular/common';

class NelBadgeComponent {
    constructor() {
        this.nelIsDot = false;
        this.nelType = 'primary';
        this.nelHidden = false;
    }
    ngOnInit() {
        if (this.nelMax && typeof this.nelMax === 'number' && this.nelValue) {
            if (this.nelValue > this.nelMax) {
                this.value = this.nelMax + '+';
                return;
            }
        }
        this.value = this.nelValue;
    }
}
NelBadgeComponent.decorators = [
    { type: Component, args: [{
                selector: 'nel-badge',
                template: "<ng-content></ng-content>\r\n<sup *ngIf=\"!nelHidden\" class=\"el-badge__content is-fixed\" [class.el-badge__content--primary]=\"nelType == 'primary'\"\r\n  [class.el-badge__content--success]=\"nelType == 'success'\" [class.el-badge__content--warning]=\"nelType == 'warning'\"\r\n  [class.el-badge__content--danger]=\"nelType == 'danger'\" [class.el-badge__content--info]=\"nelType == 'info'\"\r\n  [class.is-dot]=\"nelIsDot\">{{value}}</sup>\r\n",
                host: {
                    '[class]': `'el-badge'`
                }
            },] }
];
NelBadgeComponent.propDecorators = {
    nelValue: [{ type: Input }],
    nelMax: [{ type: Input }],
    nelIsDot: [{ type: Input }],
    nelType: [{ type: Input }],
    nelHidden: [{ type: Input }]
};
__decorate([
    InputBoolean()
], NelBadgeComponent.prototype, "nelIsDot", void 0);

class NelBadgeModule {
}
NelBadgeModule.decorators = [
    { type: NgModule, args: [{
                declarations: [
                    NelBadgeComponent
                ],
                exports: [
                    NelBadgeComponent
                ],
                imports: [
                    CommonModule
                ]
            },] }
];

/**
 * Generated bundle index. Do not edit.
 */

export { NelBadgeComponent, NelBadgeModule };
//# sourceMappingURL=ng-element-ui-badge.js.map
