import { Component, Input, NgModule } from '@angular/core';
import { NelOutletModule } from 'ng-element-ui/core/outlet';

class NelBreadcrumbComponent {
    constructor() {
        this.nelSeparator = '/';
    }
}
NelBreadcrumbComponent.decorators = [
    { type: Component, args: [{
                selector: 'nel-breadcrumb',
                template: "<ng-content></ng-content>\r\n",
                host: {
                    class: 'el-breadcrumb'
                }
            },] }
];
NelBreadcrumbComponent.propDecorators = {
    nelSeparator: [{ type: Input }]
};

class NelBreadcrumbItemComponent {
    constructor(nelBreadcrumbComponent) {
        this.nelBreadcrumbComponent = nelBreadcrumbComponent;
    }
}
NelBreadcrumbItemComponent.decorators = [
    { type: Component, args: [{
                selector: 'nel-breadcrumb-item',
                template: "<span class=\"el-breadcrumb__inner\" role=\"link\">\r\n  <ng-content></ng-content>\r\n</span>\r\n<span class=\"el-breadcrumb__separator\">\r\n  <ng-container *stringTemplate=\"nelBreadcrumbComponent.nelSeparator\">{{nelBreadcrumbComponent.nelSeparator}}\r\n  </ng-container>\r\n</span>\r\n",
                host: {
                    class: 'el-breadcrumb__item'
                }
            },] }
];
NelBreadcrumbItemComponent.ctorParameters = () => [
    { type: NelBreadcrumbComponent }
];

class NelBreadcrumbModule {
}
NelBreadcrumbModule.decorators = [
    { type: NgModule, args: [{
                declarations: [
                    NelBreadcrumbComponent,
                    NelBreadcrumbItemComponent
                ],
                exports: [
                    NelBreadcrumbComponent,
                    NelBreadcrumbItemComponent
                ],
                imports: [
                    NelOutletModule
                ]
            },] }
];

/**
 * Generated bundle index. Do not edit.
 */

export { NelBreadcrumbComponent, NelBreadcrumbItemComponent, NelBreadcrumbModule };
//# sourceMappingURL=ng-element-ui-breadcrumb.js.map
