import { Component, ChangeDetectionStrategy, ElementRef, Input, NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import { NelOutletModule } from 'ng-element-ui/core/outlet';

class NelCardComponent {
    constructor(elementRef) {
        this.elementRef = elementRef;
        this.nelBodyStyle = { padding: '20px' };
        this.nelShadow = 'always';
        this.elementRef.nativeElement.classList.add('el-card');
    }
}
NelCardComponent.decorators = [
    { type: Component, args: [{
                selector: 'nel-card',
                template: "<div class=\"el-card__header\" *ngIf=\"nelHeader\">\r\n  <div class=\"card-header\">\r\n    <ng-container *stringTemplate=\"nelHeader\">{{nelHeader}}</ng-container>\r\n  </div>\r\n</div>\r\n<div class=\"el-card__body\" [ngStyle]=\"nelBodyStyle ? nelBodyStyle : null\">\r\n  <ng-content></ng-content>\r\n</div>\r\n",
                changeDetection: ChangeDetectionStrategy.OnPush,
                host: {
                    '[class.is-always-shadow]': `nelShadow == 'always'`,
                    '[class.is-hover-shadow]': `nelShadow == 'hover'`,
                    '[class.is-never-shadow]': `nelShadow == 'never'`,
                    '[class.box-card]': `true`,
                }
            },] }
];
NelCardComponent.ctorParameters = () => [
    { type: ElementRef }
];
NelCardComponent.propDecorators = {
    nelHeader: [{ type: Input }],
    nelBodyStyle: [{ type: Input }],
    nelShadow: [{ type: Input }]
};

class NelCardModule {
}
NelCardModule.decorators = [
    { type: NgModule, args: [{
                declarations: [
                    NelCardComponent
                ],
                exports: [
                    NelCardComponent
                ],
                imports: [
                    CommonModule,
                    NelOutletModule
                ]
            },] }
];

/**
 * Generated bundle index. Do not edit.
 */

export { NelCardComponent, NelCardModule };
//# sourceMappingURL=ng-element-ui-card.js.map
