import { Component, ContentChildren, NgModule } from '@angular/core';

class NelHeaderComponent {
}
NelHeaderComponent.decorators = [
    { type: Component, args: [{
                selector: 'nel-header',
                template: "<ng-content></ng-content>\r\n",
                host: {
                    '[class.el-header]': 'true'
                }
            },] }
];

class NelFooterComponent {
}
NelFooterComponent.decorators = [
    { type: Component, args: [{
                selector: 'nel-footer',
                template: "<ng-content></ng-content>\r\n",
                host: {
                    '[class.el-footer]': 'true'
                }
            },] }
];

class NelContainerComponent {
    constructor() {
        this.vertical = false;
    }
    ngAfterContentInit() {
        if (this.headerList.length > 0 || this.footerList.length > 0) {
            this.vertical = true;
        }
    }
}
NelContainerComponent.decorators = [
    { type: Component, args: [{
                selector: 'nel-container',
                template: "<ng-content></ng-content>\r\n",
                host: {
                    '[class.el-container]': 'true',
                    '[class.is-vertical]': 'vertical'
                }
            },] }
];
NelContainerComponent.propDecorators = {
    headerList: [{ type: ContentChildren, args: [NelHeaderComponent, { descendants: false },] }],
    footerList: [{ type: ContentChildren, args: [NelFooterComponent, { descendants: false },] }]
};

class NelAsideComponent {
}
NelAsideComponent.decorators = [
    { type: Component, args: [{
                selector: 'nel-aside',
                template: "<ng-content></ng-content>\r\n",
                host: {
                    '[class.el-aside]': 'true'
                }
            },] }
];

class NelMainComponent {
}
NelMainComponent.decorators = [
    { type: Component, args: [{
                selector: 'nel-main',
                template: "<ng-content></ng-content>\r\n",
                host: {
                    '[class.el-main]': 'true'
                }
            },] }
];

class NelContainerModule {
}
NelContainerModule.decorators = [
    { type: NgModule, args: [{
                declarations: [
                    NelContainerComponent,
                    NelHeaderComponent,
                    NelAsideComponent,
                    NelMainComponent,
                    NelFooterComponent
                ],
                exports: [
                    NelContainerComponent,
                    NelHeaderComponent,
                    NelAsideComponent,
                    NelMainComponent,
                    NelFooterComponent
                ]
            },] }
];

/**
 * Generated bundle index. Do not edit.
 */

export { NelAsideComponent, NelContainerComponent, NelContainerModule, NelFooterComponent, NelHeaderComponent, NelMainComponent };
//# sourceMappingURL=ng-element-ui-container.js.map
