import { TemplateRef, Directive, ViewContainerRef, Input, NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';

class StringTemplateContext {
}
class NelStringTemplateDirective {
    constructor(vcRef, templateRef) {
        this.vcRef = vcRef;
        this.templateRef = templateRef;
        this.context = new StringTemplateContext();
        this.stringTemplate = null;
        this.stringTemplateContext = null;
    }
    updateView() {
        this.clear();
        if (!this.stringTemplate) {
            return;
        }
        const isTemplateRef = this.stringTemplate instanceof TemplateRef;
        const templateRef = (isTemplateRef ? this.stringTemplate : this.templateRef);
        this.vcRef.createEmbeddedView(templateRef, isTemplateRef ? this.stringTemplateContext : this.context);
    }
    clear() {
        this.vcRef.clear();
    }
    ngOnChanges(changes) {
        this.updateView();
    }
    ngOnDestroy() {
        this.clear();
    }
}
NelStringTemplateDirective.decorators = [
    { type: Directive, args: [{
                selector: '[stringTemplate]',
            },] }
];
NelStringTemplateDirective.ctorParameters = () => [
    { type: ViewContainerRef },
    { type: TemplateRef }
];
NelStringTemplateDirective.propDecorators = {
    stringTemplate: [{ type: Input }],
    stringTemplateContext: [{ type: Input }]
};

class NelOutletModule {
}
NelOutletModule.decorators = [
    { type: NgModule, args: [{
                declarations: [
                    NelStringTemplateDirective
                ],
                exports: [
                    NelStringTemplateDirective
                ],
                imports: [
                    CommonModule
                ]
            },] }
];

/**
 * Generated bundle index. Do not edit.
 */

export { NelOutletModule, NelStringTemplateDirective, StringTemplateContext };
//# sourceMappingURL=ng-element-ui-core-outlet.js.map
