import { Directive, ElementRef, Renderer2, Input, NgModule } from '@angular/core';
import { NelUpdateHostClassService } from 'ng-element-ui/core/services';

class NelIconDirective {
    constructor(elementRef, renderer, updateHostClassService) {
        this.elementRef = elementRef;
        this.renderer = renderer;
        this.updateHostClassService = updateHostClassService;
        this.el = this.elementRef.nativeElement;
        this.type = '';
    }
    set nelType(value) {
        this.renderer.addClass(this.el, `el-icon-${value}`);
    }
    ngOnChanges(changes) {
        if (changes.type) {
            this.setClassMap();
        }
    }
    setClassMap() {
        this.updateHostClassService.updateHostClass(this.el, {
            [`el-icon-${this.type}`]: this.type
        });
    }
}
NelIconDirective.decorators = [
    { type: Directive, args: [{
                selector: '[nel-icon]'
            },] }
];
NelIconDirective.ctorParameters = () => [
    { type: ElementRef },
    { type: Renderer2 },
    { type: NelUpdateHostClassService }
];
NelIconDirective.propDecorators = {
    nelType: [{ type: Input }]
};

class NelIconModule {
}
NelIconModule.decorators = [
    { type: NgModule, args: [{
                declarations: [
                    NelIconDirective
                ],
                exports: [
                    NelIconDirective
                ]
            },] }
];

/**
 * Generated bundle index. Do not edit.
 */

export { NelIconDirective, NelIconModule };
//# sourceMappingURL=ng-element-ui-icon.js.map
