import { __decorate } from 'tslib';
import { Component, Input, NgModule } from '@angular/core';
import { InputBoolean } from 'ng-element-ui/core/utils';
import { CommonModule } from '@angular/common';
import { NelIconModule } from 'ng-element-ui/icon';

class NelLinkComponent {
    constructor() {
        this.nelType = '';
        this.nelUnderline = true;
        this.nelDisabled = false;
        this.nelIcon = '';
    }
}
NelLinkComponent.decorators = [
    { type: Component, args: [{
                selector: 'a[nel-link]',
                template: `
    <i *ngIf="nelIcon" nel-icon [nelType]="nelIcon"></i>
    <span class="el-link--inner">
      <ng-content></ng-content>
    </span>
  `,
                host: {
                    '[class.el-link]': `true`,
                    '[class.el-link--default]': `nelType == ''`,
                    '[class.el-link--primary]': `nelType == 'primary'`,
                    '[class.el-link--success]': `nelType == 'success'`,
                    '[class.el-link--warning]': `nelType == 'warning'`,
                    '[class.el-link--danger]': `nelType == 'danger'`,
                    '[class.el-link--info]': `nelType == 'info'`,
                    '[class.is-underline]': `nelUnderline && !nelDisabled`,
                    '[class.is-disabled]': `nelDisabled`,
                }
            },] }
];
NelLinkComponent.propDecorators = {
    nelType: [{ type: Input }],
    nelUnderline: [{ type: Input }],
    nelDisabled: [{ type: Input }],
    nelIcon: [{ type: Input }]
};
__decorate([
    InputBoolean()
], NelLinkComponent.prototype, "nelDisabled", void 0);

class NelLinkModule {
}
NelLinkModule.decorators = [
    { type: NgModule, args: [{
                declarations: [
                    NelLinkComponent
                ],
                exports: [
                    NelLinkComponent
                ],
                imports: [
                    CommonModule,
                    NelIconModule
                ]
            },] }
];

/**
 * Generated bundle index. Do not edit.
 */

export { NelLinkComponent, NelLinkModule };
//# sourceMappingURL=ng-element-ui-link.js.map
