import { EventEmitter, Component, Input, Output, NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import { NelOutletModule } from 'ng-element-ui/core/outlet';
import { NelIconModule } from 'ng-element-ui/icon';

class NelPageHeaderComponent {
    constructor() {
        this.nelIcon = 'back';
        this.nelTitle = '返回';
        this.nelOnBack = new EventEmitter();
    }
    goBack() {
        this.nelOnBack.emit();
    }
}
NelPageHeaderComponent.decorators = [
    { type: Component, args: [{
                selector: 'nel-page-header',
                template: "<div class=\"el-page-header\">\r\n  <div class=\"el-page-header__left\" (click)=\"goBack()\">\r\n    <div class=\"el-page-header__icon\">\r\n      <i nel-icon [nelType]=\"nelIcon\"></i>\r\n    </div>\r\n    <div class=\"el-page-header__title\">\r\n      <ng-container *stringTemplate=\"nelTitle\">{{nelTitle}}</ng-container>\r\n    </div>\r\n  </div>\r\n  <div class=\"el-page-header__content\" *ngIf=\"nelContent\">\r\n    <ng-container *stringTemplate=\"nelContent\">{{nelContent}}</ng-container>\r\n  </div>\r\n</div>\r\n"
            },] }
];
NelPageHeaderComponent.propDecorators = {
    nelIcon: [{ type: Input }],
    nelTitle: [{ type: Input }],
    nelContent: [{ type: Input }],
    nelOnBack: [{ type: Output }]
};

class NelPageHeaderModule {
}
NelPageHeaderModule.decorators = [
    { type: NgModule, args: [{
                declarations: [
                    NelPageHeaderComponent
                ],
                exports: [
                    NelPageHeaderComponent
                ],
                imports: [
                    CommonModule,
                    NelOutletModule,
                    NelIconModule
                ]
            },] }
];

/**
 * Generated bundle index. Do not edit.
 */

export { NelPageHeaderComponent, NelPageHeaderModule };
//# sourceMappingURL=ng-element-ui-page-header.js.map
