import { __decorate } from 'tslib';
import { Component, ChangeDetectionStrategy, forwardRef, ChangeDetectorRef, Input, NgModule } from '@angular/core';
import { NG_VALUE_ACCESSOR } from '@angular/forms';
import { InputBoolean } from 'ng-element-ui/core/utils';
import { Observable } from 'rxjs';
import { CommonModule } from '@angular/common';

class NelSwitchComponent {
    constructor(cdf) {
        this.cdf = cdf;
        this.nelWidth = 40;
        this.nelDisabled = false;
        this.nelLoading = false;
        this.change = (value) => { };
    }
    changeSwitch() {
        if (!this.nelLoading && !this.nelDisabled) {
            if (this.nelBeforeChange) {
                const before = this.nelBeforeChange();
                if (before instanceof Observable) {
                    before.subscribe((data) => {
                        if (data) {
                            this.data = !this.data;
                            this.change(this.data);
                        }
                    });
                }
                else if (before !== false) {
                    this.data = !this.data;
                    this.change(this.data);
                }
            }
            else {
                this.data = !this.data;
                this.change(this.data);
            }
        }
    }
    writeValue(val) {
        if (val !== undefined) {
            this.data = val;
            this.cdf.markForCheck();
        }
    }
    registerOnChange(fn) {
        this.change = fn;
    }
    registerOnTouched(fn) { }
}
NelSwitchComponent.decorators = [
    { type: Component, args: [{
                selector: 'nel-switch',
                template: "<div class=\"el-switch\" [class.is-disabled]=\"nelLoading || nelDisabled\" [class.is-checked]=\"data\" role=\"switch\"\r\n  aria-checked=\"true\" (click)=\"changeSwitch()\">\r\n  <input class=\"el-switch__input\" type=\"checkbox\" name=\"\">\r\n  <span *ngIf=\"nelInactiveText\" class=\"el-switch__label el-switch__label--left\" [class.is-active]=\"!data\">\r\n    <span aria-hidden=\"true\">{{nelInactiveText}}</span>\r\n  </span>\r\n  <span class=\"el-switch__core\" [style.width]=\"nelWidth + 'px'\"\r\n    [style.border-color]=\"data ? nelActiveColor : nelInactiveColor\"\r\n    [style.background-color]=\"data ? nelActiveColor : nelInactiveColor\">\r\n    <div class=\"el-switch__action\" [style.color]=\"data ? nelActiveColor : nelInactiveColor\">\r\n      <i *ngIf=\"nelLoading\" class=\"el-icon-loading\"></i>\r\n    </div>\r\n  </span>\r\n  <span *ngIf=\"nelActiveText\" class=\"el-switch__label el-switch__label--right\" [class.is-active]=\"data\">\r\n    <span aria-hidden=\"false\">{{nelActiveText}}</span>\r\n  </span>\r\n</div>\r\n",
                changeDetection: ChangeDetectionStrategy.OnPush,
                providers: [
                    {
                        provide: NG_VALUE_ACCESSOR,
                        useExisting: forwardRef(() => NelSwitchComponent),
                        multi: true
                    }
                ]
            },] }
];
NelSwitchComponent.ctorParameters = () => [
    { type: ChangeDetectorRef }
];
NelSwitchComponent.propDecorators = {
    nelWidth: [{ type: Input }],
    nelActiveColor: [{ type: Input }],
    nelInactiveColor: [{ type: Input }],
    nelActiveText: [{ type: Input }],
    nelInactiveText: [{ type: Input }],
    nelDisabled: [{ type: Input }],
    nelLoading: [{ type: Input }],
    nelBeforeChange: [{ type: Input }]
};
__decorate([
    InputBoolean()
], NelSwitchComponent.prototype, "nelDisabled", void 0);
__decorate([
    InputBoolean()
], NelSwitchComponent.prototype, "nelLoading", void 0);

class NelSwitchModule {
}
NelSwitchModule.decorators = [
    { type: NgModule, args: [{
                declarations: [
                    NelSwitchComponent
                ],
                exports: [
                    NelSwitchComponent
                ],
                imports: [
                    CommonModule
                ]
            },] }
];

/**
 * Generated bundle index. Do not edit.
 */

export { NelSwitchComponent, NelSwitchModule };
//# sourceMappingURL=ng-element-ui-switch.js.map
