import { __decorate } from 'tslib';
import { EventEmitter, Component, Input, Output, NgModule } from '@angular/core';
import { InputBoolean } from 'ng-element-ui/core/utils';
import { CommonModule } from '@angular/common';
import { NelIconModule } from 'ng-element-ui/icon';

class NelTagComponent {
    constructor() {
        this.nelClosable = false;
        this.nelEffect = 'light';
        this.nelOnClose = new EventEmitter();
    }
    close() {
        this.nelOnClose.emit();
    }
}
NelTagComponent.decorators = [
    { type: Component, args: [{
                selector: 'nel-tag',
                template: "<ng-content></ng-content>\r\n<i *ngIf=\"nelClosable\" (click)=\"close()\" nel-icon [nelType]=\"'close'\" class=\"el-tag__close\"></i>\r\n",
                host: {
                    '[class]': `'el-tag'`,
                    '[class.el-tag--success]': `nelType == 'success'`,
                    '[class.el-tag--info]': `nelType == 'info'`,
                    '[class.el-tag--warning]': `nelType == 'warning'`,
                    '[class.el-tag--danger]': `nelType == 'danger'`,
                    '[class.el-tag--medium]': `nelSize == 'medium'`,
                    '[class.el-tag--small]': `nelSize == 'small'`,
                    '[class.el-tag--mini]': `nelSize == 'mini'`,
                    '[class.el-tag--dark]': `nelEffect == 'dark'`,
                    '[class.el-tag--light]': `nelEffect == 'light'`,
                    '[class.el-tag--plain]': `nelEffect == 'plain'`,
                }
            },] }
];
NelTagComponent.propDecorators = {
    nelType: [{ type: Input }],
    nelClosable: [{ type: Input }],
    nelSize: [{ type: Input }],
    nelEffect: [{ type: Input }],
    nelOnClose: [{ type: Output }]
};
__decorate([
    InputBoolean()
], NelTagComponent.prototype, "nelClosable", void 0);

class NelCheckTagComponent {
    constructor() {
        this.nelChecked = false;
    }
}
NelCheckTagComponent.decorators = [
    { type: Component, args: [{
                selector: 'nel-check-tag',
                template: "<ng-content></ng-content>\r\n",
                host: {
                    '[class]': `'el-check-tag'`,
                    '[class.is-checked]': 'nelChecked'
                }
            },] }
];
NelCheckTagComponent.propDecorators = {
    nelChecked: [{ type: Input }]
};
__decorate([
    InputBoolean()
], NelCheckTagComponent.prototype, "nelChecked", void 0);

class NelTagModule {
}
NelTagModule.decorators = [
    { type: NgModule, args: [{
                declarations: [
                    NelTagComponent,
                    NelCheckTagComponent
                ],
                exports: [
                    NelTagComponent,
                    NelCheckTagComponent
                ],
                imports: [
                    CommonModule,
                    NelIconModule
                ]
            },] }
];

/**
 * Generated bundle index. Do not edit.
 */

export { NelCheckTagComponent, NelTagComponent, NelTagModule };
//# sourceMappingURL=ng-element-ui-tag.js.map
