import { Component, Input, NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import { NelIconModule } from 'ng-element-ui/icon';

class NelTimelineComponent {
}
NelTimelineComponent.decorators = [
    { type: Component, args: [{
                selector: 'nel-timeline',
                template: "<ul class=\"el-timeline\">\r\n  <ng-content></ng-content>\r\n</ul>\r\n"
            },] }
];

class NelTimelineItemComponent {
    constructor() {
        this.nelSize = 'normal';
        this.nelHideTimestamp = false;
    }
}
NelTimelineItemComponent.decorators = [
    { type: Component, args: [{
                selector: 'nel-timeline-item',
                template: "<div class=\"el-timeline-item__tail\"></div>\r\n<div class=\"el-timeline-item__node el-timeline-item__node--\"\r\n  [class.el-timeline-item__node--normal]=\"nelSize == 'normal'\"\r\n  [class.el-timeline-item__node--large]=\"nelSize != 'normal'\"\r\n  [class.el-timeline-item__node--primary]=\"nelType == 'primary'\"\r\n  [class.el-timeline-item__node--success]=\"nelType == 'success'\"\r\n  [class.el-timeline-item__node--warning]=\"nelType == 'warning'\"\r\n  [class.el-timeline-item__node--danger]=\"nelType == 'danger'\" [class.el-timeline-item__node--info]=\"nelType == 'info'\"\r\n  [style.backgroundColor]=\"nelColor\">\r\n  <i *ngIf=\"nelIcon\" nel-icon [nelType]=\"nelIcon\" class=\"el-timeline-item__icon\"></i>\r\n</div>\r\n<div class=\"el-timeline-item__wrapper\">\r\n  <div *ngIf=\"!nelHideTimestamp && nelPlacement == 'top'\" class=\"el-timeline-item__timestamp is-top\">{{nelTimestamp}}\r\n  </div>\r\n  <div class=\"el-timeline-item__content\">\r\n    <ng-content></ng-content>\r\n  </div>\r\n  <div *ngIf=\"!nelHideTimestamp && nelPlacement == 'bottom'\" class=\"el-timeline-item__timestamp is-bottom\">\r\n    {{nelTimestamp}}</div>\r\n</div>\r\n",
                host: {
                    class: 'el-timeline-item'
                }
            },] }
];
NelTimelineItemComponent.propDecorators = {
    nelTimestamp: [{ type: Input }],
    nelSize: [{ type: Input }],
    nelColor: [{ type: Input }],
    nelType: [{ type: Input }],
    nelIcon: [{ type: Input }],
    nelPlacement: [{ type: Input }],
    nelHideTimestamp: [{ type: Input }]
};

class NelTimelineModule {
}
NelTimelineModule.decorators = [
    { type: NgModule, args: [{
                declarations: [
                    NelTimelineComponent,
                    NelTimelineItemComponent
                ],
                exports: [
                    NelTimelineComponent,
                    NelTimelineItemComponent
                ],
                imports: [
                    CommonModule,
                    NelIconModule
                ]
            },] }
];

/**
 * Generated bundle index. Do not edit.
 */

export { NelTimelineComponent, NelTimelineItemComponent, NelTimelineModule };
//# sourceMappingURL=ng-element-ui-timeline.js.map
