import { TemplateRef, AfterViewInit, ElementRef, OnDestroy, ChangeDetectorRef, EventEmitter } from '@angular/core';
import { BooleanInput } from '@angular/cdk/coercion';
import { Subscription } from 'rxjs';
import { NelImageService } from './image.service';
export declare class NelImageComponent implements AfterViewInit, OnDestroy {
    private elementRef;
    private cdr;
    private image;
    static ngAcceptInputType_nelLazy: BooleanInput;
    loading: boolean;
    hasLoadError: boolean;
    src?: string;
    nelSrc?: string;
    nelFit?: string;
    nelAlt?: string;
    nelPlaceholder?: string | TemplateRef<void>;
    nelError?: string | TemplateRef<void>;
    nelLazy: boolean;
    nelPreviewSrcList?: string[];
    nelOnLoad: EventEmitter<Event>;
    nelOnError: EventEmitter<Error>;
    container: HTMLElement;
    subscribeLazy: Subscription;
    constructor(elementRef: ElementRef, cdr: ChangeDetectorRef, image: NelImageService);
    ngOnDestroy(): void;
    ngAfterViewInit(): void;
    loadImage(): void;
    lazyImage(): void;
    handlerLoad(e: Event): void;
    handlerError(e: Error): void;
    handleLazy(): void;
    preview(): void;
}
