import { Injector, TemplateRef } from '@angular/core';
import { Overlay } from '@angular/cdk/overlay';
import { Subject } from 'rxjs';
import { MessageRef } from './message-ref';
export interface OptionsType {
    showClose?: boolean;
    duration?: number;
    center?: boolean;
    onClose?: Function;
}
export declare class NelMessageService {
    private overlay;
    private injector;
    messageId: number;
    leave: Subject<number>;
    messageRefList: Array<MessageRef>;
    constructor(overlay: Overlay, injector: Injector);
    info<R = any>(content: string | TemplateRef<void>, options?: OptionsType): MessageRef<R>;
    success<R = any>(content: string | TemplateRef<void>, options?: OptionsType): MessageRef<R>;
    warning<R = any>(content: string | TemplateRef<void>, options?: OptionsType): MessageRef<R>;
    error<R = any>(content: string | TemplateRef<void>, options?: OptionsType): MessageRef<R>;
    show<R = any>(type: string, content: string | TemplateRef<void>, options?: OptionsType): MessageRef<R>;
    createInjector(ref: MessageRef, inj: Injector): Injector;
    private _handlerLeave;
}
