import { TemplateRef, Injector } from '@angular/core';
import { Overlay } from '@angular/cdk/overlay';
import { Subject } from 'rxjs';
import { NelNotificationRef, PositionType } from './notification-ref';
export interface OptionsType {
    duration?: number;
    position?: string;
    offset?: number;
    showClose?: boolean;
    onClose?: Function;
}
export declare class NelNotificationService {
    private overlay;
    private injector;
    notificationId: number;
    leave: Subject<{
        id: number;
        position: PositionType;
    }>;
    notificationRefList: {
        topRight: Array<NelNotificationRef>;
        bottomRight: Array<NelNotificationRef>;
        topLeft: Array<NelNotificationRef>;
        bottomLeft: Array<NelNotificationRef>;
    };
    constructor(overlay: Overlay, injector: Injector);
    blank<R = any>(title: string | TemplateRef<void>, content: string | TemplateRef<void>, options?: OptionsType): NelNotificationRef<R>;
    success<R = any>(title: string | TemplateRef<void>, content: string | TemplateRef<void>, options?: OptionsType): NelNotificationRef<R>;
    warning<R = any>(title: string | TemplateRef<void>, content: string | TemplateRef<void>, options?: OptionsType): NelNotificationRef<R>;
    info<R = any>(title: string | TemplateRef<void>, content: string | TemplateRef<void>, options?: OptionsType): NelNotificationRef<R>;
    error<R = any>(title: string | TemplateRef<void>, content: string | TemplateRef<void>, options?: OptionsType): NelNotificationRef<R>;
    show<R = any>(type: string, title: string | TemplateRef<void>, content: string | TemplateRef<void>, options?: OptionsType): NelNotificationRef<R>;
    createInjector(ref: NelNotificationRef, inj: Injector): Injector;
    private _handlerLeave;
}
