import { ElementRef, ViewContainerRef, ComponentFactory, ComponentFactoryResolver, EventEmitter, Renderer2 } from '@angular/core';
import { NelPopconfirmComponent } from './popconfirm.component';
export declare type PlacementType = 'top' | 'top-start' | 'top-end' | 'bottom' | 'bottom-start' | 'bottom-end' | 'left' | 'left-start' | 'left-end' | 'right' | 'right-start' | 'right-end';
export declare class NelPopconfirmDirective {
    protected hostView: ViewContainerRef;
    private elementRef;
    private resolver;
    private renderer;
    nelPopconfirmTitle?: string;
    nelPlacement: PlacementType;
    nelConfirmButtonText: string;
    nelCancelButtonText: string;
    nelConfirmButtonType: string;
    nelCancelButtonType: string;
    nelIcon: string;
    nelIconColor: string;
    nelHideIcon: boolean;
    nelOnCancel: EventEmitter<void>;
    nelOnConfirm: EventEmitter<void>;
    protected componentFactory: ComponentFactory<NelPopconfirmComponent>;
    component?: NelPopconfirmComponent;
    constructor(hostView: ViewContainerRef, elementRef: ElementRef, resolver: ComponentFactoryResolver, renderer: Renderer2);
    onClick(): void;
    show(): void;
}
