import { ComponentFactory, ViewContainerRef, ElementRef, ComponentFactoryResolver, Renderer2, OnDestroy, TemplateRef, OnInit, EventEmitter } from '@angular/core';
import { NelPopoverComponent } from './popover.component';
export declare type PlacementType = 'top' | 'top-start' | 'top-end' | 'bottom' | 'bottom-start' | 'bottom-end' | 'left' | 'left-start' | 'left-end' | 'right' | 'right-start' | 'right-end';
export declare type TriggerType = 'click' | 'focus' | 'hover' | 'manual';
export declare class NelPopoverDirective implements OnInit, OnDestroy {
    protected hostView: ViewContainerRef;
    private elementRef;
    private resolver;
    private renderer;
    nelPopoverTitle?: string;
    nelPopoverContent?: string | TemplateRef<void>;
    nelPopoverWidth?: number;
    nelPopoverTrigger: TriggerType;
    nelPopoverPlacement: PlacementType;
    set nelPopoverVisible(val: boolean);
    nelPopoverVisibleChange: EventEmitter<boolean>;
    protected componentFactory: ComponentFactory<NelPopoverComponent>;
    component?: NelPopoverComponent;
    protected readonly triggerDisposables: Array<() => void>;
    constructor(hostView: ViewContainerRef, elementRef: ElementRef, resolver: ComponentFactoryResolver, renderer: Renderer2);
    ngOnDestroy(): void;
    ngOnInit(): void;
    trigger(): void;
    private removeTriggerListeners;
    show(): void;
    hide(): void;
}
