import { OnInit, TemplateRef } from '@angular/core';
export declare type NelProgressFormatter = ((percentage: number) => string | null) | TemplateRef<{
    $implicit: number;
}>;
export declare type NelProgressType = ((percentage: number) => string | null);
export declare class NelProgressComponent implements OnInit {
    nelPercentage: number;
    nelFormat?: NelProgressFormatter;
    nelStatus?: 'success' | 'exception' | 'warning';
    nelStrokeWidth: number;
    nelTextInside: boolean;
    nelColor?: string | NelProgressType | Array<string | {
        color: string;
        percentage: number;
    }>;
    nelType: 'line' | 'circle' | 'dashboard';
    nelWidth: number;
    nelStrokeLinecap: string;
    nelIndeterminate: boolean;
    nelDuration: number;
    get formatter(): NelProgressFormatter;
    get formatterText(): NelProgressType;
    get relativeStrokeWidth(): string;
    get radius(): number;
    get trackPath(): string;
    get perimeter(): number;
    get rate(): number;
    get strokeDashoffset(): string;
    get trailPathStyle(): any;
    get circlePathStyle(): any;
    get stroke(): string | null;
    ngOnInit(): void;
    getCurrentColor(): string | null;
}
