import { AfterViewInit, ElementRef, OnDestroy, EventEmitter } from '@angular/core';
import { Subscription } from 'rxjs';
import ResizeObserver from 'resize-observer-polyfill';
export declare class NelScrollbarComponent implements AfterViewInit, OnDestroy {
    maxHeight?: string;
    nelHeight?: string;
    nelNoresize: boolean;
    set nelMaxHeight(val: string | number | undefined);
    nelWrapClass?: string;
    nelViewClass?: string;
    nelOnScroll: EventEmitter<any>;
    scrollbarWrap: ElementRef;
    scrollbarView: ElementRef;
    verticalThumb: ElementRef;
    horizontalThumb: ElementRef;
    vertical: {
        canScroll: boolean;
        wrapHeight: number;
        scrollHeight: number;
        maxScrollTop: number;
        scrollTop: number;
        clientY: number;
        clientTop: number;
    };
    verticalMousemove: Subscription;
    verticalMouseup: Subscription;
    horizontal: {
        canScroll: boolean;
        wrapWidth: number;
        scrollWidth: number;
        maxScrollLeft: number;
        scrollLeft: number;
        clientX: number;
        clientLeft: number;
    };
    horizontalMousemove: Subscription;
    horizontalMouseup: Subscription;
    status: string;
    inThumb: boolean;
    roWrap?: ResizeObserver;
    roView?: ResizeObserver;
    ngOnDestroy(): void;
    ngAfterViewInit(): void;
    initVertical(): void;
    initHorizontal(): void;
    onWrapScroll($event: any): void;
    verticalScrollHandle(scrollTop?: boolean): void;
    mouseEnter(): void;
    mouseLeave(): void;
    verticalThumbDown($event: MouseEvent): void;
    verticalThumbMove($event: MouseEvent): void;
    horizontalThumbDown($event: MouseEvent): void;
    horizontalThumbMove($event: MouseEvent): void;
    horizontalScrollHandle(scrollTop?: boolean): void;
}
