import { QueryList, AfterContentInit, ElementRef, AfterViewInit, OnChanges, SimpleChanges, EventEmitter, AfterContentChecked, ChangeDetectorRef } from '@angular/core';
import { BooleanInput } from '@angular/cdk/coercion';
import { NelTabPaneComponent } from './tab-pane.component';
export declare class NelTabsComponent implements AfterContentInit, AfterContentChecked, AfterViewInit, OnChanges {
    private cdr;
    static ngAcceptInputType_nelEditable: BooleanInput;
    _tabLabelCount: number;
    _tabItems: any[];
    activeBar: {
        width: string;
        height: string;
        transform: string;
    };
    scrollable: boolean;
    scrollTransform: string;
    nelSelectedIndex: number;
    nelType?: 'card' | 'border-card';
    nelTabPosition: 'top' | 'right' | 'left' | 'bottom' | string;
    nelEditable: boolean;
    items: QueryList<NelTabPaneComponent>;
    tabItems: QueryList<ElementRef<any>>;
    navScroll: ElementRef<any>;
    navScrollPosition: ElementRef<any>;
    nelSelectedIndexChange: EventEmitter<number>;
    nelOnEdit: EventEmitter<{
        index: number;
        action: string;
    }>;
    constructor(cdr: ChangeDetectorRef);
    ngAfterContentInit(): void;
    ngAfterContentChecked(): void;
    ngAfterViewInit(): void;
    ngOnChanges(changes: SimpleChanges): void;
    changeTabPane(): void;
    selecteTab(val: number): void;
    changeTab(init: boolean): void;
    changeScroll(): void;
    edit(): void;
    remove(event: MouseEvent, _index: number): void;
}
