import { Overlay, OverlayPositionBuilder } from '@angular/cdk/overlay';
import { ElementRef, TemplateRef, OnInit } from '@angular/core';
export declare type PlacementType = 'top' | 'top-start' | 'top-end' | 'bottom' | 'bottom-start' | 'bottom-end' | 'left' | 'left-start' | 'left-end' | 'right' | 'right-start' | 'right-end';
export declare type EffectType = 'dark' | 'light';
export declare class NelTooltipDirective implements OnInit {
    private overlay;
    private overlayPositionBuilder;
    private elementRef;
    nelContent?: string | TemplateRef<void>;
    nelPlacement: PlacementType;
    nelEffect: EffectType;
    set nelDisabled(value: boolean);
    private overlayRef?;
    disabled: boolean;
    constructor(overlay: Overlay, overlayPositionBuilder: OverlayPositionBuilder, elementRef: ElementRef);
    ngOnInit(): void;
    onMouseenter(): void;
    onMouseleave(): void;
    show(): void;
    hide(): void;
}
